module CShoe
    use CShoeVariables
    implicit none    
    public    
    contains 
    
    subroutine SetShoeFormationNo(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetShoeFormationNo
    !DEC$ ATTRIBUTES ALIAS: 'SetShoeFormationNo' :: SetShoeFormationNo
        implicit none
        integer, intent(in) :: v
        FormationNo = v
    end subroutine
        
    subroutine SetShoeDepth(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetShoeDepth
    !DEC$ ATTRIBUTES ALIAS: 'SetShoeDepth' :: SetShoeDepth
        implicit none
        real*8, intent(in) :: v
        ShoeDepth = v
    end subroutine
    
    subroutine SetLeakOff(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetLeakOff
    !DEC$ ATTRIBUTES ALIAS: 'SetLeakOff' :: SetLeakOff
        implicit none
        real*8, intent(in) :: v
        LeakOff = v
    end subroutine
    
    subroutine SetBreakdown(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetBreakdown
    !DEC$ ATTRIBUTES ALIAS: 'SetBreakdown' :: SetBreakdown
        implicit none
        real*8, intent(in) :: v
        Breakdown = v
    end subroutine
    
    subroutine SetFracturePropagation(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetFracturePropagation
    !DEC$ ATTRIBUTES ALIAS: 'SetFracturePropagation' :: SetFracturePropagation
        implicit none
        real*8, intent(in) :: v
        FracturePropagation = v
    end subroutine
    
    subroutine SetInactiveFracture(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetInactiveFracture
    !DEC$ ATTRIBUTES ALIAS: 'SetInactiveFracture' :: SetInactiveFracture
        implicit none
        logical, intent(in) :: v
        InactiveFracture = v
    end subroutine
    
end module CShoe