module CBopStack
    use CBopStackVariables
    use CLog4
    implicit none    
    public
    contains
          
    subroutine SetAboveAnnularHeight(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetAboveAnnularHeight
    !DEC$ ATTRIBUTES ALIAS: 'SetAboveAnnularHeight' :: SetAboveAnnularHeight
        implicit none
        real*8, intent(in) :: v
        !AboveAnnularHeight = v
        !call Log_4('AboveAnnularHeight=', AboveAnnularHeight)
    end subroutine
    
    subroutine SetAnnularPreventerHeight(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetAnnularPreventerHeight
    !DEC$ ATTRIBUTES ALIAS: 'SetAnnularPreventerHeight' :: SetAnnularPreventerHeight
        implicit none
        real*8, intent(in) :: v
        !AnnularPreventerHeight = v
        !call Log_4('AnnularPreventerHeight=', AnnularPreventerHeight)
    end subroutine
    
    subroutine SetUpperRamHeight(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetUpperRamHeight
    !DEC$ ATTRIBUTES ALIAS: 'SetUpperRamHeight' :: SetUpperRamHeight
        implicit none
        real*8, intent(in) :: v
        !UpperRamHeight = v
        !call Log_4('UpperRamHeight=', UpperRamHeight)
    end subroutine
    
    subroutine SetLowerRamHeight(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetLowerRamHeight
    !DEC$ ATTRIBUTES ALIAS: 'SetLowerRamHeight' :: SetLowerRamHeight
        implicit none
        real*8, intent(in) :: v
        !LowerRamHeight = v
        !call Log_4('LowerRamHeight=', LowerRamHeight)
    end subroutine
    
    subroutine SetBlindRamHeight(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetBlindRamHeight
    !DEC$ ATTRIBUTES ALIAS: 'SetBlindRamHeight' :: SetBlindRamHeight
        implicit none
        real*8, intent(in) :: v
        !BlindRamHeight = v
        !call Log_4('BlindRamHeight=', BlindRamHeight)
    end subroutine
    
    subroutine SetKillHeight(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetKillHeight
    !DEC$ ATTRIBUTES ALIAS: 'SetKillHeight' :: SetKillHeight
        implicit none
        real*8, intent(in) :: v
        !KillHeight = v
        !call Log_4('KillHeight=', KillHeight)
    end subroutine
    
    subroutine SetKillOpen(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetKillOpen
    !DEC$ ATTRIBUTES ALIAS: 'SetKillOpen' :: SetKillOpen
        implicit none
        real*8, intent(in) :: v
        !KillOpen = v
        !call Log_4('KillOpen=', KillOpen)
    end subroutine
    
    subroutine SetKillClose(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetKillClose
    !DEC$ ATTRIBUTES ALIAS: 'SetKillClose' :: SetKillClose
        implicit none
        real*8, intent(in) :: v
        !KillClose = v
        !call Log_4('KillClose=', KillClose)
    end subroutine
    
    subroutine SetGroundLevel(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetGroundLevel
    !DEC$ ATTRIBUTES ALIAS: 'SetGroundLevel' :: SetGroundLevel
        implicit none
        real*8, intent(in) :: v
        !GroundLevel = v
        !call Log_4('GroundLevel=', GroundLevel)
    end subroutine
    
    subroutine SetLowerRamOpen(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetLowerRamOpen
    !DEC$ ATTRIBUTES ALIAS: 'SetLowerRamOpen' :: SetLowerRamOpen
        implicit none
        real*8, intent(in) :: v
        LowerRamOpen = v
    end subroutine
    
    subroutine SetLowerRamClose(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetLowerRamClose
    !DEC$ ATTRIBUTES ALIAS: 'SetLowerRamClose' :: SetLowerRamClose
        implicit none
        real*8, intent(in) :: v
        LowerRamClose = v
    end subroutine
    
    subroutine SetChokeOpen(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetChokeOpen
    !DEC$ ATTRIBUTES ALIAS: 'SetChokeOpen' :: SetChokeOpen
        implicit none
        real*8, intent(in) :: v
        ChokeOpen = v
    end subroutine
    
    subroutine SetChokeClose(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetChokeClose
    !DEC$ ATTRIBUTES ALIAS: 'SetChokeClose' :: SetChokeClose
        implicit none
        real*8, intent(in) :: v
        ChokeClose = v
    end subroutine
    
    subroutine SetBlindRamOpen(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetBlindRamOpen
    !DEC$ ATTRIBUTES ALIAS: 'SetBlindRamOpen' :: SetBlindRamOpen
        implicit none
        real*8, intent(in) :: v
        BlindRamOpen = v
    end subroutine
    
    subroutine SetBlindRamClose(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetBlindRamClose
    !DEC$ ATTRIBUTES ALIAS: 'SetBlindRamClose' :: SetBlindRamClose
        implicit none
        real*8, intent(in) :: v
        BlindRamClose = v
    end subroutine
    
    subroutine SetUpperRamOpen(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetUpperRamOpen
    !DEC$ ATTRIBUTES ALIAS: 'SetUpperRamOpen' :: SetUpperRamOpen
        implicit none
        real*8, intent(in) :: v
        UpperRamOpen = v
    end subroutine
    
    subroutine SetUpperRamClose(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetUpperRamClose
    !DEC$ ATTRIBUTES ALIAS: 'SetUpperRamClose' :: SetUpperRamClose
        implicit none
        real*8, intent(in) :: v
        UpperRamClose = v
    end subroutine
    
    subroutine SetAnnularPreventerOpen(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetAnnularPreventerOpen
    !DEC$ ATTRIBUTES ALIAS: 'SetAnnularPreventerOpen' :: SetAnnularPreventerOpen
        implicit none
        real*8, intent(in) :: v
        AnnularPreventerOpen = v
    end subroutine
    
    subroutine SetAnnularPreventerClose(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetAnnularPreventerClose
    !DEC$ ATTRIBUTES ALIAS: 'SetAnnularPreventerClose' :: SetAnnularPreventerClose
        implicit none
        real*8, intent(in) :: v
        AnnularPreventerClose = v
    end subroutine
    
    subroutine SetRamStringDrag(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetRamStringDrag
    !DEC$ ATTRIBUTES ALIAS: 'SetRamStringDrag' :: SetRamStringDrag
        implicit none
        real*8, intent(in) :: v
        RamStringDrag = v
    end subroutine
    
    subroutine SetAnnularStringDrag(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetAnnularStringDrag
    !DEC$ ATTRIBUTES ALIAS: 'SetAnnularStringDrag' :: SetAnnularStringDrag
        implicit none
        real*8, intent(in) :: v
        AnnularStringDrag = v
    end subroutine       
    
    subroutine SetChokeLineLength(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetChokeLineLength
    !DEC$ ATTRIBUTES ALIAS: 'SetChokeLineLength' :: SetChokeLineLength
        implicit none
        real*8, intent(in) :: v
        ChokeLineLength = v
    end subroutine
    
    subroutine SetChokeLineId(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetChokeLineId
    !DEC$ ATTRIBUTES ALIAS: 'SetChokeLineId' :: SetChokeLineId
        implicit none
        real*8, intent(in) :: v
        ChokeLineId = v
    end subroutine
    
end module CBopStack