module CPower
    use CPowerVariables
    implicit none    
    public    
    contains   
    
    subroutine SetNumberOfgenerators(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetNumberOfgenerators
    !DEC$ ATTRIBUTES ALIAS: 'SetNumberOfgenerators' :: SetNumberOfgenerators
        implicit none
        integer, intent(in) :: v
        NumberOfgenerators = v
    end subroutine
    
    subroutine SetGeneratorPowerRating(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetGeneratorPowerRating
    !DEC$ ATTRIBUTES ALIAS: 'SetGeneratorPowerRating' :: SetGeneratorPowerRating
        implicit none
        real*8, intent(in) :: v
        GeneratorPowerRating = v
    end subroutine
    
    subroutine SetMudPump1(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetMudPump1
    !DEC$ ATTRIBUTES ALIAS: 'SetMudPump1' :: SetMudPump1
        implicit none
        real*8, intent(in) :: v
        MudPump1 = v
    end subroutine
    
    subroutine SetMudPump2(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetMudPump2
    !DEC$ ATTRIBUTES ALIAS: 'SetMudPump2' :: SetMudPump2
        implicit none
        real*8, intent(in) :: v
        MudPump2 = v
    end subroutine
    
    subroutine SetCementPump(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetCementPump
    !DEC$ ATTRIBUTES ALIAS: 'SetCementPump' :: SetCementPump
        implicit none
        real*8, intent(in) :: v
        CementPump = v
    end subroutine
    
    subroutine SetRotaryTable(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetRotaryTable
    !DEC$ ATTRIBUTES ALIAS: 'SetRotaryTable' :: SetRotaryTable
        implicit none
        real*8, intent(in) :: v
        RotaryTable = v
    end subroutine
    
    subroutine SetDrawworks(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetDrawworks
    !DEC$ ATTRIBUTES ALIAS: 'SetDrawworks' :: SetDrawworks
        implicit none
        real*8, intent(in) :: v
        Drawworks = v
    end subroutine
        
    subroutine SetTopDrive(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetTopDrive
    !DEC$ ATTRIBUTES ALIAS: 'SetTopDrive' :: SetTopDrive
        implicit none
        real*8, intent(in) :: v
        TopDrive = v
    end subroutine
    
end module CPower