module CRigSize
    use CRigSizeVariables
    implicit none    
    public 
    contains    
    subroutine SetRigType(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetRigType
    !DEC$ ATTRIBUTES ALIAS: 'SetRigType' :: SetRigType
        implicit none
        integer, intent(in) :: v
        RigType = v            
    end subroutine
        
    subroutine SetCrownHeight(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetCrownHeight
    !DEC$ ATTRIBUTES ALIAS: 'SetCrownHeight' :: SetCrownHeight
        implicit none
        real*8, intent(in) :: v
        CrownHeight = v            
    end subroutine
        
    subroutine SetMonkeyBoandHeight(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetMonkeyBoandHeight
    !DEC$ ATTRIBUTES ALIAS: 'SetMonkeyBoandHeight' :: SetMonkeyBoandHeight
        implicit none
        real*8, intent(in) :: v
        MonkeyBoandHeight = v            
    end subroutine
        
    subroutine SetRigFloorHeight(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetRigFloorHeight
    !DEC$ ATTRIBUTES ALIAS: 'SetRigFloorHeight' :: SetRigFloorHeight
        implicit none
        real*8, intent(in) :: v
        RigFloorHeight = v            
    end subroutine
end module CRigSize