module CCasingLinerChoke
    use CCasingLinerChokeVariables
    implicit none    
    public    
    contains   
    
    subroutine SetCasingDepth(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetCasingDepth
    !DEC$ ATTRIBUTES ALIAS: 'SetCasingDepth' :: SetCasingDepth
        implicit none
        real*8, intent(in) :: v
        CasingDepth = v
    end subroutine
    
    subroutine SetCasingId(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetCasingId
    !DEC$ ATTRIBUTES ALIAS: 'SetCasingId' :: SetCasingId
        implicit none
        real*8, intent(in) :: v
        CasingId = v
    end subroutine
    
    subroutine SetCasingOd(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetCasingOd
    !DEC$ ATTRIBUTES ALIAS: 'SetCasingOd' :: SetCasingOd
        implicit none
        real*8, intent(in) :: v
        CasingOd = v
    end subroutine
    
    subroutine SetCasingWeight(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetCasingWeight
    !DEC$ ATTRIBUTES ALIAS: 'SetCasingWeight' :: SetCasingWeight
        implicit none
        real*8, intent(in) :: v
        CasingWeight = v
    end subroutine
    
    subroutine SetCasingCollapsePressure(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetCasingCollapsePressure
    !DEC$ ATTRIBUTES ALIAS: 'SetCasingCollapsePressure' :: SetCasingCollapsePressure
        implicit none
        real*8, intent(in) :: v
        CasingCollapsePressure = v
    end subroutine
    
    subroutine SetCasingTensileStrength(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetCasingTensileStrength
    !DEC$ ATTRIBUTES ALIAS: 'SetCasingTensileStrength' :: SetCasingTensileStrength
        implicit none
        real*8, intent(in) :: v
        CasingTensileStrength = v
    end subroutine
    
    
    
    
    
    
    
    
    subroutine SetLinerTopDepth(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetLinerTopDepth
    !DEC$ ATTRIBUTES ALIAS: 'SetLinerTopDepth' :: SetLinerTopDepth
        implicit none
        real*8, intent(in) :: v
        LinerTopDepth = v
    end subroutine
    
    subroutine SetLinerLength(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetLinerLength
    !DEC$ ATTRIBUTES ALIAS: 'SetLinerLength' :: SetLinerLength
        implicit none
        real*8, intent(in) :: v
        LinerLength = v
    end subroutine
    
    subroutine SetLinerId(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetLinerId
    !DEC$ ATTRIBUTES ALIAS: 'SetLinerId' :: SetLinerId
        implicit none
        real*8, intent(in) :: v
        LinerId = v
    end subroutine
    
    subroutine SetLinerOd(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetLinerOd
    !DEC$ ATTRIBUTES ALIAS: 'SetLinerOd' :: SetLinerOd
        implicit none
        real*8, intent(in) :: v
        LinerOd = v
    end subroutine
    
    subroutine SetLinerWeight(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetLinerWeight
    !DEC$ ATTRIBUTES ALIAS: 'SetLinerWeight' :: SetLinerWeight
        implicit none
        real*8, intent(in) :: v
        LinerWeight = v
    end subroutine
    
    subroutine SetLinerCollapsePressure(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetLinerCollapsePressure
    !DEC$ ATTRIBUTES ALIAS: 'SetLinerCollapsePressure' :: SetLinerCollapsePressure
        implicit none
        real*8, intent(in) :: v
        LinerCollapsePressure = v
    end subroutine
    
    subroutine SetLinerTensileStrength(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetLinerTensileStrength
    !DEC$ ATTRIBUTES ALIAS: 'SetLinerTensileStrength' :: SetLinerTensileStrength
        implicit none
        real*8, intent(in) :: v
        LinerTensileStrength = v
    end subroutine
    
    
    
    subroutine SetOpenHoleId(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetOpenHoleId
    !DEC$ ATTRIBUTES ALIAS: 'SetOpenHoleId' :: SetOpenHoleId
	    implicit none
	    real*8, intent(in) :: v
	    OpenHoleId = v
#ifdef deb
	    print*, 'OpenHoleId=', OpenHoleId
#endif
    end subroutine

    subroutine SetOpenHoleLength(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetOpenHoleLength
    !DEC$ ATTRIBUTES ALIAS: 'SetOpenHoleLength' :: SetOpenHoleLength
	    implicit none
	    real*8, intent(in) :: v
	    OpenHoleLength = v
#ifdef deb
	    print*, 'OpenHoleLength=', OpenHoleLength
#endif
    end subroutine
    
    
    
    
end module CCasingLinerChoke