module CCommon
    use CCommonVariables
    implicit none    
    public    
    contains  
    
    ! Input routines
    subroutine SetStandRack(v)
	    implicit none
	    integer, intent(in) :: v
        if(StandRack == v) return
	    StandRack = v
        call OnStandRackChange%Run(v)
#ifdef deb
        print*, 'StandRack=', StandRack
#endif
    end subroutine
    
    
    subroutine SetStandRack_WN(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetStandRack_WN
    !DEC$ ATTRIBUTES ALIAS: 'SetStandRack_WN' :: SetStandRack_WN
	    implicit none
	    integer, intent(in) :: v
        call SetStandRack(v)
    end subroutine
    
    
    
    ! Output routines
    logical function GetDrillWatchOperationMode()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetDrillWatchOperationMode
    !DEC$ ATTRIBUTES ALIAS: 'GetDrillWatchOperationMode' :: GetDrillWatchOperationMode
	    implicit none
	    GetDrillWatchOperationMode = DrillWatchOperationMode
    end function
    
    integer function GetStandRack()
	    implicit none
	    GetStandRack = StandRack
    end function
    
    integer function GetStandRack_WN()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetStandRack_WN
    !DEC$ ATTRIBUTES ALIAS: 'GetStandRack_WN' :: GetStandRack_WN
	    implicit none
	    GetStandRack_WN = StandRack
    end function
    
    
    
    
end module CCommon