module CDrillWatch
	use CDrillWatchVariables
    !use CSimulationVariables
	implicit none    
	public    
	contains  
	
	! Input routines

	! Output routines
	
	real(8) function GetDepth()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetDepth
	!DEC$ ATTRIBUTES ALIAS: 'GetDepth' :: GetDepth
		implicit none
		GetDepth = Depth
		!GetDepth = Depth + 10 + SimulationTime
    end function
    
    real(8) function GetBitPosition()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetBitPosition
	!DEC$ ATTRIBUTES ALIAS: 'GetBitPosition' :: GetBitPosition
		implicit none
		GetBitPosition = BitPosition
		!GetBitPosition = BitPosition + 20 + SimulationTime
	end function

	real(8) function GetHookLoadD()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetHookLoadD
	!DEC$ ATTRIBUTES ALIAS: 'GetHookLoadD' :: GetHookLoadD
		implicit none
		GetHookLoadD = HookLoad
		!GetHookLoadD = HookLoad + 30 + SimulationTime
	end function

	real(8) function GetWeightOnBit()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetWeightOnBit
	!DEC$ ATTRIBUTES ALIAS: 'GetWeightOnBit' :: GetWeightOnBit
		implicit none
		GetWeightOnBit = WeightOnBit
		!GetWeightOnBit = WeightOnBit + 40 + SimulationTime
	end function

	real(8) function GetRPM()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetRPM
	!DEC$ ATTRIBUTES ALIAS: 'GetRPM' :: GetRPM
		implicit none
		GetRPM = RPM
		!GetRPM = RPM + 50 + SimulationTime
	end function
	
	real(8) function GetROP2()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetROP2
	!DEC$ ATTRIBUTES ALIAS: 'GetROP2' :: GetROP2
		implicit none
		GetROP2 = ROP
		!GetROP2 = ROP + 60 + SimulationTime
	end function

	real(8) function GetTorque()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetTorque
	!DEC$ ATTRIBUTES ALIAS: 'GetTorque' :: GetTorque
		implicit none
        GetTorque = Torque
		!GetTorque = Torque + 70 + SimulationTime
	end function

	real(8) function GetPumpPressureD()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetPumpPressureD
	!DEC$ ATTRIBUTES ALIAS: 'GetPumpPressureD' :: GetPumpPressureD
		implicit none
		GetPumpPressureD = PumpPressure
		!GetPumpPressureD = PumpPressure + 80 + SimulationTime
	end function

	real(8) function GetSPM1()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetSPM1
	!DEC$ ATTRIBUTES ALIAS: 'GetSPM1' :: GetSPM1
		implicit none
		GetSPM1 = SPM1
		!GetSPM1 = SPM1 + 90 + SimulationTime
	end function

	real(8) function GetSPM2()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetSPM2
	!DEC$ ATTRIBUTES ALIAS: 'GetSPM2' :: GetSPM2
		implicit none
		GetSPM2 = SPM2
		!GetSPM2 = SPM2 + 100 + SimulationTime
    end function
    
 !   real(8) function GetSPM3()
	!!DEC$ ATTRIBUTES DLLEXPORT :: GetSPM3
	!!DEC$ ATTRIBUTES ALIAS: 'GetSPM3' :: GetSPM3
	!	implicit none
	!	GetSPM3 = SPM3
	!end function

	real(8) function GetCasingPressureD()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetCasingPressureD
	!DEC$ ATTRIBUTES ALIAS: 'GetCasingPressureD' :: GetCasingPressureD
		implicit none
		GetCasingPressureD = CasingPressure
		!GetCasingPressureD = CasingPressure + 110 + SimulationTime
	end function

	real(8) function GetPercentFlow()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetPercentFlow
	!DEC$ ATTRIBUTES ALIAS: 'GetPercentFlow' :: GetPercentFlow
		implicit none
		GetPercentFlow = PercentFlow
		!GetPercentFlow = PercentFlow + 120 + SimulationTime
	end function

	real(8) function GetPitGainLose()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetPitGainLose
	!DEC$ ATTRIBUTES ALIAS: 'GetPitGainLose' :: GetPitGainLose
		implicit none
		GetPitGainLose = PitGainLose
		!GetPitGainLose = PitGainLose + 130 + SimulationTime
	end function
	
	real(8) function GetPitVolume()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetPitVolume
	!DEC$ ATTRIBUTES ALIAS: 'GetPitVolume' :: GetPitVolume
		implicit none
		GetPitVolume = PitVolume
		!GetPitVolume = PitVolume + 140 + SimulationTime
	end function

	real(8) function GetKillMudVolume()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetKillMudVolume
	!DEC$ ATTRIBUTES ALIAS: 'GetKillMudVolume' :: GetKillMudVolume
		implicit none
		GetKillMudVolume = KillMudVolume
		!GetKillMudVolume = KillMudVolume + 150 + SimulationTime
	end function

	real(8) function GetTripTankVolume()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetTripTankVolume
	!DEC$ ATTRIBUTES ALIAS: 'GetTripTankVolume' :: GetTripTankVolume
		implicit none
		GetTripTankVolume = TripTankVolume
		!GetTripTankVolume = TripTankVolume + 160 + SimulationTime
	end function

	real(8) function GetMudWeightInD()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetMudWeightInD
	!DEC$ ATTRIBUTES ALIAS: 'GetMudWeightInD' :: GetMudWeightInD
		implicit none
		GetMudWeightInD = MudWeightIn
		!GetMudWeightInD = MudWeightIn + 170 + SimulationTime
	end function

	real(8) function GetFillVolume()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetFillVolume
	!DEC$ ATTRIBUTES ALIAS: 'GetFillVolume' :: GetFillVolume
		implicit none
		GetFillVolume = FillVolume
		!GetFillVolume = FillVolume + 180 + SimulationTime
	end function

	real(8) function GetMudWeightOutD()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetMudWeightOutD
	!DEC$ ATTRIBUTES ALIAS: 'GetMudWeightOutD' :: GetMudWeightOutD
		implicit none
		GetMudWeightOutD = MudWeightOut
		!GetMudWeightOutD = MudWeightOut + 190 + SimulationTime
	end function

end module CDrillWatch