module CTdsTorqueWrenchLedNotificationVariables
    use CVoidEventHandlerCollection
    implicit none
    integer :: TorqueWrenchLed = 0
    
    public
    
    type(VoidEventHandlerCollection) :: OnTorqueWrenchLedChange
        
    private :: TorqueWrenchLed
    
    contains
    
    subroutine Set_TorqueWrenchLed(v)
        use CTopDrivePanelVariables, only: TopDriveTorqueWrenchLed
        implicit none
        integer , intent(in) :: v
        
#ifdef ExcludeExtraChanges
        if(TorqueWrenchLed == v) return
#endif
        TorqueWrenchLed = v
        TopDriveTorqueWrenchLed = v
        call OnTorqueWrenchLedChange%RunAll()
    end subroutine
    
    logical function Get_TorqueWrenchLed()
        implicit none
        Get_TorqueWrenchLed = TorqueWrenchLed
    end function
    
    
    
    
    subroutine Set_TorqueWrenchLed_WN(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: Set_TorqueWrenchLed_WN
    !DEC$ ATTRIBUTES ALIAS: 'Set_TorqueWrenchLed_WN' :: Set_TorqueWrenchLed_WN
        implicit none
        integer , intent(in) :: v
        call Set_TorqueWrenchLed(v)
    end subroutine
    
    logical function Get_TorqueWrenchLed_WN()
    !DEC$ ATTRIBUTES DLLEXPORT :: Get_TorqueWrenchLed_WN
    !DEC$ ATTRIBUTES ALIAS: 'Get_TorqueWrenchLed_WN' :: Get_TorqueWrenchLed_WN
        implicit none
        Get_TorqueWrenchLed_WN = TorqueWrenchLed
    end function
    
end module CTdsTorqueWrenchLedNotificationVariables