module CBucketEnum
    use COperationScenariosVariables
    implicit none
    contains
    
    subroutine Evaluate_MudBucket()
        use CStudentStationVariables, only: MudBoxInstallation
        implicit none
        
        
!        if (DriveType == TopDrive_DriveType) then
!#ifdef OST
!            print*, 'Evaluate_MudBucket=TopDrive'
!#endif
!        endif
!        
!        
!        
!        
!        if (DriveType == Kelly_DriveType) then
!#ifdef OST
!            print*, 'Evaluate_MudBucket=Kelly'
!#endif
!        endif
        
        
        if (Get_MudBucket() == MUD_BUCKET_INSTALL) then
            MudBoxInstallation = .true.
        else if (Get_MudBucket() == MUD_BUCKET_REMOVE) then
            MudBoxInstallation = .false.
        endif
        
    end subroutine
    
    ! subroutine Subscribe_MudBucket()
    !     use CStudentStationVariables
    !     implicit none
    !     call OnMudBoxInstallationPress%Add(ButtonPress_MudBoxInstallation)
    !     call OnMudBoxRemovePress%Add(ButtonPress_MudBoxRemove)
    ! end subroutine
    
    subroutine ButtonPress_MudBoxInstallation()
        implicit none
        
        
        if (DriveType == TopDrive_DriveType) then
#ifdef OST
            print*, 'ButtonPress_MudBoxInstallation=TopDrive'
#endif
        endif
        if (DriveType == Kelly_DriveType) then
#ifdef OST
            print*, 'ButtonPress_MudBoxInstallation=Kelly'
#endif
            

            call Set_MudBucket(MUD_BUCKET_INSTALL)

        endif
        
        
        
        
        
    end subroutine
    
    subroutine ButtonPress_MudBoxRemove()
        implicit none
        
        
        if (DriveType == TopDrive_DriveType) then
#ifdef OST
            print*, 'ButtonPress_MudBoxRemove=TopDrive'
#endif
        endif
        if (DriveType == Kelly_DriveType) then
#ifdef OST
            print*, 'ButtonPress_MudBoxRemove=Kelly'
#endif


            call Set_MudBucket(MUD_BUCKET_REMOVE)

        endif
        
        
        
        
        
        
    end subroutine
    
end module CBucketEnum