module CHeadEnum
    use COperationScenariosVariables
    implicit none
    contains
    
    subroutine Evaluate_FillupHead()
        use CStudentStationVariables, only: FillupHeadInstallation
        implicit none
        
        
        if (DriveType == TopDrive_DriveType) then
#ifdef OST
            print*, 'Evaluate_FillupHead=TopDrive'
#endif
        endif
        
        
        
        
        
        
        if (DriveType == Kelly_DriveType) then
#ifdef OST
            print*, 'Evaluate_FillupHead=Kelly'
#endif
        endif
        
        
        if (Get_FillupHead() == FILLUP_HEAD_INSTALL) then
            FillupHeadInstallation = .true.
        else if (Get_FillupHead() == FILLUP_HEAD_REMOVE) then
            FillupHeadInstallation = .false.
        endif
        
    end subroutine
    
    ! subroutine Subscribe_FillupHead()
    !     use CStudentStationVariables
    !     implicit none
    !     call OnFillupHeadInstallationPress%Add(ButtonPress_FillupHeadInstallation)
    !     call OnFillupHeadRemovePress%Add(ButtonPress_FillupHeadRemove)
    ! end subroutine
    
    subroutine ButtonPress_FillupHeadInstallation()
        implicit none
        
        
        
        
        
        if (DriveType == TopDrive_DriveType) then
#ifdef OST
            print*, 'ButtonPress_FillupHeadInstallation=TopDrive'
#endif



            !TOPDRIVE-CODE=67
            if (Get_FillupHeadPermission()) then
                call Set_FillupHead(FILLUP_HEAD_INSTALL)
            
                return
            end if


        endif
        
        
        
        
        
        
        if (DriveType == Kelly_DriveType) then
#ifdef OST
            print*, 'ButtonPress_FillupHeadInstallation=Kelly'
#endif


            !OPERATION-CODE=71
            if (Get_InstallFillupHeadPermission()) then
                call Set_FillupHead(FILLUP_HEAD_INSTALL)
            
                return
            end if


        endif
        
        
        
        
        
        
        
    end subroutine
    
    
    subroutine ButtonPress_FillupHeadRemove()
        implicit none
        
        
        
        
        
        if (DriveType == TopDrive_DriveType) then
#ifdef OST
            print*, 'ButtonPress_FillupHeadRemove=TopDrive'
#endif


            !TOPDRIVE-CODE=68
            if (Get_FillupHeadPermission()) then
                call Set_FillupHead(FILLUP_HEAD_REMOVE)
            
                return
            end if


        endif
        
        
        
        
        
        
        if (DriveType == Kelly_DriveType) then
#ifdef OST
            print*, 'ButtonPress_FillupHeadRemove=Kelly'
#endif


            !OPERATION-CODE=72
            if (Get_InstallFillupHeadPermission()) then
                call Set_FillupHead(FILLUP_HEAD_REMOVE)
                return
            end if
            



        endif
        
        
        
        
        
        
    end subroutine
    
end module CHeadEnum