module CBitProblems
	use CBitProblemsVariables
	implicit none    
	public 
    contains   
    
    ! Input routines
    subroutine SetPlugJets(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetPlugJets
    !DEC$ ATTRIBUTES ALIAS: 'SetPlugJets' :: SetPlugJets
	    implicit none
	    type(CProblem), intent(in) :: v
	    PlugJets = SetDue(v, ChangePlugJets)
#ifdef deb
	    !print*, 'PlugJets%ProblemType=', PlugJets%ProblemType
	    !print*, 'PlugJets%StatusType=', PlugJets%StatusType
	    !print*, 'PlugJets%Value=', PlugJets%Value
	    !print*, 'PlugJets%DueValue=', PlugJets%DueValue
        
        call Log_3("==============================")
        call Log_3("PlugJets%ProblemType=", PlugJets%ProblemType)
	    call Log_3("PlugJets%StatusType=", PlugJets%StatusType)
	    call Log_3("PlugJets%Value=", PlugJets%Value)
	    call Log_3("PlugJets%DueValue=", PlugJets%DueValue)
        call Log_3("==============================")
#endif
    end subroutine

    subroutine SetJetWashout(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetJetWashout
    !DEC$ ATTRIBUTES ALIAS: 'SetJetWashout' :: SetJetWashout
	    implicit none
	    type(CProblem), intent(in) :: v
	    JetWashout = SetDue(v, ChangeJetWashout)
#ifdef deb
	    print*, 'JetWashout%ProblemType=', JetWashout%ProblemType
	    print*, 'JetWashout%StatusType=', JetWashout%StatusType
	    print*, 'JetWashout%Value=', JetWashout%Value
	    print*, 'JetWashout%DueValue=', JetWashout%DueValue
#endif
    end subroutine

    subroutine SetPlugJetsCount(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetPlugJetsCount
    !DEC$ ATTRIBUTES ALIAS: 'SetPlugJetsCount' :: SetPlugJetsCount
	    implicit none
	    integer, intent(in) :: v
	    PlugJetsCount = v
#ifdef deb
	    print*, 'PlugJetsCount=', PlugJetsCount
#endif
    end subroutine

    subroutine SetJetWashoutCount(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetJetWashoutCount
    !DEC$ ATTRIBUTES ALIAS: 'SetJetWashoutCount' :: SetJetWashoutCount
	    implicit none
	    integer, intent(in) :: v
	    JetWashoutCount = v
#ifdef deb
	    print*, 'JetWashoutCount=', JetWashoutCount
#endif
    end subroutine
    
end module CBitProblems