module CMudTreatmentProblems
    use CMudTreatmentProblemsVariables
	implicit none    
	public 
    contains   
    
    ! Input routines
	subroutine SetDegasser(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetDegasser
	!DEC$ ATTRIBUTES ALIAS: 'SetDegasser' :: SetDegasser
		implicit none
		type(CProblem), intent(in) :: v
		Degasser = SetDue(v, ChangeDegasser)
#ifdef deb
	    print*, 'Degasser%ProblemType=', V%ProblemType
	    print*, 'Degasser%StatusType=', V%StatusType
	    print*, 'Degasser%Value=', V%Value
#endif
	end subroutine

	subroutine SetShaleShaker(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetShaleShaker
	!DEC$ ATTRIBUTES ALIAS: 'SetShaleShaker' :: SetShaleShaker
		implicit none
		type(CProblem), intent(in) :: v
		ShaleShaker = SetDue(v, ChangeShaleShaker)
#ifdef deb
	    print*, 'ShaleShaker%ProblemType=', V%ProblemType
	    print*, 'ShaleShaker%StatusType=', V%StatusType
	    print*, 'ShaleShaker%Value=', V%Value
#endif
	end subroutine

	subroutine SetDesander(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetDesander
	!DEC$ ATTRIBUTES ALIAS: 'SetDesander' :: SetDesander
		implicit none
		type(CProblem), intent(in) :: v
		Desander = SetDue(v, ChangeDesander)
#ifdef deb
	    print*, 'Desander%ProblemType=', V%ProblemType
	    print*, 'Desander%StatusType=', V%StatusType
	    print*, 'Desander%Value=', V%Value
#endif
	end subroutine

	subroutine SetDesilter(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetDesilter
	!DEC$ ATTRIBUTES ALIAS: 'SetDesilter' :: SetDesilter
		implicit none
		type(CProblem), intent(in) :: v
		Desilter = SetDue(v, ChangeDesilter)
#ifdef deb
	    print*, 'Desilter%ProblemType=', V%ProblemType
	    print*, 'Desilter%StatusType=', V%StatusType
	    print*, 'Desilter%Value=', V%Value
#endif
    end subroutine

end module CMudTreatmentProblems