module COtherProblems
    use COtherProblemsVariables
	implicit none    
	public 
    contains   
    
    ! Input routines
	subroutine SetRigAlarm(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetRigAlarm
	!DEC$ ATTRIBUTES ALIAS: 'SetRigAlarm' :: SetRigAlarm
		implicit none
		type(CProblem), intent(in) :: v
		RigAlarm = SetDue(v, ChangeRigAlarm)
#ifdef deb
	    print*, 'RigAlarm%ProblemType=', V%ProblemType
	    print*, 'RigAlarm%StatusType=', V%StatusType
	    print*, 'RigAlarm%Value=', V%Value
#endif
	end subroutine

	subroutine SetRigWaterSupply(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetRigWaterSupply
	!DEC$ ATTRIBUTES ALIAS: 'SetRigWaterSupply' :: SetRigWaterSupply
		implicit none
		type(CProblem), intent(in) :: v
		RigWaterSupply = SetDue(v, ChangeRigWaterSupply)
#ifdef deb
	    print*, 'RigWaterSupply%ProblemType=', V%ProblemType
	    print*, 'RigWaterSupply%StatusType=', V%StatusType
	    print*, 'RigWaterSupply%Value=', V%Value
#endif
	end subroutine

	subroutine SetRigAir(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetRigAir
	!DEC$ ATTRIBUTES ALIAS: 'SetRigAir' :: SetRigAir
		implicit none
		type(CProblem), intent(in) :: v
		RigAir = SetDue(v, ChangeRigAir)
#ifdef deb
	    print*, 'RigAir%ProblemType=', V%ProblemType
	    print*, 'RigAir%StatusType=', V%StatusType
	    print*, 'RigAir%Value=', V%Value
#endif
	end subroutine

	subroutine SetGen1(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetGen1
	!DEC$ ATTRIBUTES ALIAS: 'SetGen1' :: SetGen1
		implicit none
		type(CProblem), intent(in) :: v
		Gen1 = SetDue(v, ChangeGen1)
#ifdef deb
	    print*, 'Gen1%ProblemType=', V%ProblemType
	    print*, 'Gen1%StatusType=', V%StatusType
	    print*, 'Gen1%Value=', V%Value
#endif
	end subroutine

	subroutine SetGen2(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetGen2
	!DEC$ ATTRIBUTES ALIAS: 'SetGen2' :: SetGen2
		implicit none
		type(CProblem), intent(in) :: v
		Gen2 = SetDue(v, ChangeGen2)
#ifdef deb
	    print*, 'Gen2%ProblemType=', V%ProblemType
	    print*, 'Gen2%StatusType=', V%StatusType
	    print*, 'Gen2%Value=', V%Value
#endif
	end subroutine

	subroutine SetGen3(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetGen3
	!DEC$ ATTRIBUTES ALIAS: 'SetGen3' :: SetGen3
		implicit none
		type(CProblem), intent(in) :: v
		Gen3 = SetDue(v, ChangeGen3)
#ifdef deb
	    print*, 'Gen3%ProblemType=', V%ProblemType
	    print*, 'Gen3%StatusType=', V%StatusType
	    print*, 'Gen3%Value=', V%Value
#endif
	end subroutine

	subroutine SetGen4(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetGen4
	!DEC$ ATTRIBUTES ALIAS: 'SetGen4' :: SetGen4
		implicit none
		type(CProblem), intent(in) :: v
		Gen4 = SetDue(v, ChangeGen4)
#ifdef deb
	    print*, 'Gen4%ProblemType=', V%ProblemType
	    print*, 'Gen4%StatusType=', V%StatusType
	    print*, 'Gen4%Value=', V%Value
#endif
	end subroutine

	subroutine SetScr1(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetScr1
	!DEC$ ATTRIBUTES ALIAS: 'SetScr1' :: SetScr1
		implicit none
		type(CProblem), intent(in) :: v
		Scr1 = SetDue(v, ChangeScr1)
#ifdef deb
	    print*, 'Scr1%ProblemType=', V%ProblemType
	    print*, 'Scr1%StatusType=', V%StatusType
	    print*, 'Scr1%Value=', V%Value
#endif
	end subroutine

	subroutine SetScr2(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetScr2
	!DEC$ ATTRIBUTES ALIAS: 'SetScr2' :: SetScr2
		implicit none
		type(CProblem), intent(in) :: v
		Scr2 = SetDue(v, ChangeScr2)
#ifdef deb
	    print*, 'Scr2%ProblemType=', V%ProblemType
	    print*, 'Scr2%StatusType=', V%StatusType
	    print*, 'Scr2%Value=', V%Value
#endif
	end subroutine

	subroutine SetScr3(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetScr3
	!DEC$ ATTRIBUTES ALIAS: 'SetScr3' :: SetScr3
		implicit none
		type(CProblem), intent(in) :: v
		Scr3 = SetDue(v, ChangeScr3)
#ifdef deb
	    print*, 'Scr3%ProblemType=', V%ProblemType
	    print*, 'Scr3%StatusType=', V%StatusType
	    print*, 'Scr3%Value=', V%Value
#endif
	end subroutine

	subroutine SetScr4(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetScr4
	!DEC$ ATTRIBUTES ALIAS: 'SetScr4' :: SetScr4
		implicit none
		type(CProblem), intent(in) :: v
		Scr4 = SetDue(v, ChangeScr4)
#ifdef deb
	    print*, 'Scr4%ProblemType=', V%ProblemType
	    print*, 'Scr4%StatusType=', V%StatusType
	    print*, 'Scr4%Value=', V%Value
#endif
    end subroutine

end module COtherProblems