module CRotaryProblems
    use CRotaryProblemsVariables
	implicit none    
	public 
    contains
    
    ! Input routines
    subroutine SetMotorFail2(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetMotorFail2
    !DEC$ ATTRIBUTES ALIAS: 'SetMotorFail2' :: SetMotorFail2
	    implicit none
	    type(CProblem), intent(in) :: v
	    MotorFail = SetDue(v, ChangeMotorFail)
#ifdef deb
	    print*, 'MotorFail%ProblemType=', V%ProblemType
	    print*, 'MotorFail%StatusType=', V%StatusType
	    print*, 'MotorFail%Value=', V%Value
#endif
    end subroutine

    subroutine SetOverideTorqueLimit2(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetOverideTorqueLimit2
    !DEC$ ATTRIBUTES ALIAS: 'SetOverideTorqueLimit2' :: SetOverideTorqueLimit2
	    implicit none
	    type(CProblem), intent(in) :: v
	    OverideTorqueLimit = SetDue(v, ChangeOverideTorqueLimit)
#ifdef deb
	    print*, 'OverideTorqueLimit%ProblemType=', V%ProblemType
	    print*, 'OverideTorqueLimit%StatusType=', V%StatusType
	    print*, 'OverideTorqueLimit%Value=', V%Value
#endif
    end subroutine

end module CRotaryProblems