    SUBROUTINE Choke_StartUp()
    
    USE CHOKEVARIABLES
    USE CChokeProblemsVariables
    implicit none 
    
  CALL LOSS_INPUTS_CHOKE()
    
    !OPEN(150,FILE='CHOKE_AIRPUMP_OUTPUTS.DAT')
    
    
    !CHOOKE(1)%WashoutMalf=1
    !CHOOKE(1)%PlugMalf=0
    !CHOOKE(1)%FailMalf=0
    !
    !CHOOKE(2)%WashoutMalf=1
    !CHOOKE(2)%PlugMalf=0
    !CHOOKE(2)%FailMalf=0 
    !
    !
    !ChokeAirFail=0
    !
    !GaugeChokePositionMailf=0

    
    
    
    
    
    
    kRatio=1.4
Cp=0.24
CL=0.8

x1=0.5  
 
LiquidPPG=9.
LiquidDensity=LiquidPPG*7.48 !lbm/ft**3

VL=1.0/LiquidDensity   !SpecificVolume of Liquid

Cv=Cp/kRatio

nPolytripic=1+(x1*(Cp-Cv)/(x1*Cv+(1-x1)*CL))
    
VG1=1./0.748    !lbm/ft**3 Specific Volume of Air, Upstream

Cdrag=0.8
Pwh=1400. !psi


Patm=14.7
MixDens2=x1*VG1 !lbm/ft**3



epsilon_abs= 1e-5
epsilon_step= 1e-5


!ChokeDiameter= 32/64.  !in

CHOOKE%PercentClose= 0.0
       !AreaChoke=0.01334635

  ! CHOOKE(1)%AreaChoke=0.01334635
!ChokeAreaFullyOpen = 123.d0 / 64.d0     ! fully open area is 123/64 in^2 = 0.01334635 ft^2

DeltaT_Choke=0.1
!TotalStrokes1=0.
!TotalStrokes2=0.

HydraulicChoke1WashoutCoef= 0.0
HydraulicChoke2WashoutCoef= 0.0



ChokePlugTimeDelay = int(180./DeltaT_Choke)       ! =1800 = 180/0.1 : for 3 min delay

Present_HydraulicChoke1Plug = REAL(HydraulicChoke1PluggedPercent)/100.
HydraulicChoke1PluggedPercent_Old= HydraulicChoke1PluggedPercent
Plug1TimeCounter= 0
DeltaPlug1Percent = 0.0

Present_HydraulicChoke2Plug = REAL(HydraulicChoke2PluggedPercent)/100.
HydraulicChoke2PluggedPercent_Old= HydraulicChoke2PluggedPercent
Plug2TimeCounter= 0
DeltaPlug2Percent = 0.0




    

!======================AIRPUMP INPUTS(CONSTANTS)===========================
    CourseBase= 24. !cm
    CHOOKE%PassedCourse= 0.
    ChokePosition=0.

    Acylinder= PI*(8.**2)/4.        !  (CM^2),  8=DIAMETER,   24=course ,  3785.412: cm^3 to galon


    CHOOKE%ChokeIsOpening = .false.
    CHOOKE%ChokeIsClosing = .false. 
         
         
    P_AIRP=0

    cc1 =  0.1354; cc2 = -2.066; cc3 = -21.09; cc4 = -51.36; cc5 = 5935           ! FOR OUTPUT IN GPM
    ! cc1 = 4.754e-07; cc2 = -0.0001676; cc3 = -0.03953; cc4 = -2.223; cc5 = 5935         FOR OUTPUT IN IN^3/MIN


Pdownstrem= 4950 !+0.01*Pchoke   (psi)       <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Qiter=5.  !(gpm)

! Q=0.0003585; true
time=0
tol_air=0.05

alpha_Qair=0
alpha_timeair=0
alpha_Pdownstrem=Pdownstrem
alpha_diffpair=0
alpha_lossesair=0












    end