subroutine TopDrive_OffMode
    
    use TopDrive_VARIABLES
    !use CDataDisplayConsoleVariables
    !use CDrillingConsoleVariables
    use CSimulationVariables
    use CWarningsVariables
    use CSounds
    use CTopDrivePanelVariables
    
	IMPLICIT NONE
    
    
    !==================================================================
    !                  Rate limit for off Mode
        
    if ( ((TDS%N_old-0.0d0)/TDS%time_step)>386.0d0 ) then
            TDS%N_ref = (-386.0d0*TDS%time_step)+TDS%N_old
            !else
            !    TDS%N_ref=0.0d0
            !end if
            
            CALL TopDrive_INPUTS
            CALL TopDrive_Solver
            TDS%N_old = TDS%N_ref
            !if ( TDS_OldTransMode==0 .and. TDS%w_new/=0.d0 ) then
            !    Call Activate_RotaryGearsAbuse()
            !    TDS%SoundGearCrash = .true.
            !    Call SetSoundRtGearCrash(TDS%SoundGearCrash)
            !else
            !    TDS%SoundGearCrash = .false.
            !    Call SetSoundRtGearCrash(TDS%SoundGearCrash)
            !end if
            !TDS_OldTransMode = RTTransmissionLever
        
    !==================================================================
    else
    
        TDS%N_ref  = 0.
        TDS%N_new  = 0.
        TDS%N_old  = 0.
    
    
        TDS%ia     = 0.
        TDS%ia_old = 0.
        TDS%ia_new = 0.
        TDS%x      = 0.
        TDS%x_old  = 0.
        TDS%x_new  = 0.
        TDS%y      = 0.
        TDS%y_old  = 0.
        TDS%y_new  = 0.
        TDS%w      = 0.
        TDS%w_old  = 0.
        TDS%w_new  = 0.
        TDS%Speed  = 0.
        TDS_wOld   = 0.
    
    
        TopDriveOperationFaultLed = 0
        TDS%Speed = 0.d0                 !Speed [RPM]
        TopDriveRpmGauge  = TDS%Speed
        TD_RPMUnityOutput = -TopDriveRpmGauge
        TDS%SoundRPM      = 0
        !Call SetSound( TDS%SoundRPM )
        TDS%Torque           = 0.d0      ![ft.lbf]
        TopDriveTorqueGauge  = 0.d0      ![ft.lbf]
        TDS_OldPowerMode     = 1
    
        TDS_OldPowerMode = 0
    
    End if
    
    
end subroutine