subroutine TD_ForceDownB(i,TD_SemiMudVisc)
    
   Use TD_DrillStemComponents
   Use TD_WellElements
   Use TD_WellGeometry
   Use TD_GeneralData
   

   implicit none
    
   Integer :: i
   Real(8) :: TD_SemiMudVisc
   
   If (i==1) then
       TD_DrillStems(1)%Force1 = -TD_WeightOnBit
       TD_DrillStems(1)%Force2 = (TD_DrillStems(1)%Force1 * exp(-(TD_SemiMudVisc*TD_DrillStems(1)%MudVisCorrectCoef)*(TD_DrillStems(1)%EndAngle-TD_DrillStems(1)%StartAngle))) - &
                               (TD_DrillStems(1)%WeightperLength * TD_DrillStems(1)%RCurvature * &
                               (sin(TD_DrillStems(1)%EndAngle) - (exp(-(TD_SemiMudVisc*TD_DrillStems(1)%MudVisCorrectCoef) * &
                               (TD_DrillStems(1)%EndAngle-TD_DrillStems(1)%StartAngle)) * &
                               sin(TD_DrillStems(1)%StartAngle))))
       
       if (TD_DrillStems(i)%ComponentType==0) then
           TD_DrillStems(i)%Torque = TD_BitTorque
       else
           TD_DrillStems(i)%Torque = (TD_SemiMudVisc * TD_DrillStems(i)%RtoolJoint * (TD_DrillStems(i)%Force1 + (TD_DrillStems(i)%WeightperLength * &
                            TD_DrillStems(i)%RCurvature * sin(TD_DrillStems(i)%StartAngle))) * &
                            abs(TD_DrillStems(i)%EndAngle-TD_DrillStems(i)%StartAngle)) + &
                            (2.0d0 * TD_SemiMudVisc * TD_DrillStems(i)%RtoolJoint * &
                            TD_DrillStems(i)%WeightperLength * TD_DrillStems(i)%RCurvature * &
                            (cos(TD_DrillStems(i)%EndAngle) - cos(TD_DrillStems(i)%StartAngle)))
       end if
       
       
       
       return
   End If
   
   
   
!=========> F1 Calculation
   TD_DrillStems(i)%Force1 = TD_DrillStems(i-1)%Force2
   
    
!=========> F2 Calculation
    TD_DrillStems(i)%Force2 = (TD_DrillStems(i)%Force1 * exp(-(TD_SemiMudVisc*TD_DrillStems(i)%MudVisCorrectCoef)*(TD_DrillStems(i)%EndAngle-TD_DrillStems(i)%StartAngle))) - &
                               (TD_DrillStems(i)%WeightperLength * TD_DrillStems(i)%RCurvature * &
                               (sin(TD_DrillStems(i)%EndAngle) - (exp(-(TD_SemiMudVisc*TD_DrillStems(i)%MudVisCorrectCoef) * &
                               (TD_DrillStems(i)%EndAngle-TD_DrillStems(i)%StartAngle)) * &
                               sin(TD_DrillStems(i)%StartAngle))))
    
    
    
    !    
    !    Strains(i)%Dl = TDForces(i)%Force * (Elements(i)%Length  ) / &
    !                         (Elements(i)%Area * Element%ElasticModule)
    !    
    
    TD_DrillStems(i)%Torque = (TD_SemiMudVisc * TD_DrillStems(i)%RtoolJoint * (TD_DrillStems(i)%Force1 + (TD_DrillStems(i)%WeightperLength * &
                            TD_DrillStems(i)%RCurvature * sin(TD_DrillStems(i)%StartAngle))) * &
                            abs(TD_DrillStems(i)%EndAngle-TD_DrillStems(i)%StartAngle)) + &
                            (2.0d0 * TD_SemiMudVisc * TD_DrillStems(i)%RtoolJoint * &
                            TD_DrillStems(i)%WeightperLength * TD_DrillStems(i)%RCurvature * &
                            (cos(TD_DrillStems(i)%EndAngle) - cos(TD_DrillStems(i)%StartAngle)))
        
end subroutine 