subroutine TD_ForceUpBRot(i,TD_SemiMudVisc)
    
   Use TD_DrillStemComponents
   Use TD_WellElements
   Use TD_WellGeometry
   Use TD_GeneralData
   

   implicit none
   
   Integer :: i
   Real(8) :: TD_SemiMudVisc
   
   
   If (i==1) then
       TD_DrillStems(1)%Force1 = -TD_WeightOnBit
       TD_DrillStems(1)%Force2 = TD_DrillStems(1)%Force1 + (TD_DrillStems(1)%Force1 * &
                               (exp(+(TD_SemiMudVisc*TD_DrillStems(1)%MudVisCorrectCoef)*abs(TD_DrillStems(1)%EndAngle-TD_DrillStems(1)%StartAngle))-1.0d0) * &
                               sin(TD_DrillStems(1)%CombVelRatio )) + (TD_DrillStems(1)%BouyancyFactor * &
                               TD_DrillStems(1)%WeightperLength * TD_DrillStems(1)%Length * &
                               ((sin(TD_DrillStems(1)%EndAngle)-sin(TD_DrillStems(1)%StartAngle))/ &
                               (TD_DrillStems(1)%EndAngle-TD_DrillStems(1)%StartAngle)))
       
       
       if (TD_DrillStems(i)%ComponentType==0) then
           TD_DrillStems(i)%Torque = TD_BitTorque
       else
           TD_DrillStems(i)%Torque = TD_SemiMudVisc*TD_DrillStems(i)%RtoolJoint*TD_DrillStems(i)%Force1* &
                                abs(TD_DrillStems(i)%EndAngle-TD_DrillStems(i)%StartAngle)*cos(TD_DrillStems(i)%CombVelRatio)
       end if
       
       
       return
   End If
   
   
!=========> F1 Calculation
   TD_DrillStems(i)%Force1 = TD_DrillStems(i-1)%Force2
   
    
!=========> F2 Calculation
        TD_DrillStems(i)%Force2 = TD_DrillStems(i)%Force1 + (TD_DrillStems(i)%Force1 * &
                               (exp(+(TD_SemiMudVisc*TD_DrillStems(i)%MudVisCorrectCoef)*abs(TD_DrillStems(i)%EndAngle-TD_DrillStems(i)%StartAngle))-1.0d0) * &
                               sin(TD_DrillStems(i)%CombVelRatio )) + (TD_DrillStems(i)%BouyancyFactor * &
                               TD_DrillStems(i)%WeightperLength * TD_DrillStems(i)%Length * &
                               ((sin(TD_DrillStems(i)%EndAngle)-sin(TD_DrillStems(i)%StartAngle))/ &
                               (TD_DrillStems(i)%EndAngle-TD_DrillStems(i)%StartAngle)))
        !
        !Strains(i)%Dl = TDForces(i)%Force * (Elements(i)%Length) / &
        !                     (Elements(i)%Area * Element%ElasticModule)
        !
        TD_DrillStems(i)%Torque = TD_SemiMudVisc*TD_DrillStems(i)%RtoolJoint*TD_DrillStems(i)%Force1* &
                                abs(TD_DrillStems(i)%EndAngle-TD_DrillStems(i)%StartAngle)*cos(TD_DrillStems(i)%CombVelRatio)
        
    
end subroutine