subroutine TD_StaticHookLoadCalculation
    
   Use TD_DrillStemComponents
   Use TD_WellElements
   Use TD_WellGeometry
   Use TD_GeneralData
   

   implicit none
   
   Integer :: i
   
   
   
   
   
   i = 1
    if(TD_DrillStems(i)%HoleType == 0) then
         TD_DrillStems(i)%StaticHookLoad = TD_DrillStems(i)%WeightperLength * TD_DrillStems(i)%Length * &
                                            TD_DrillStems(i)%BouyancyFactor * cos(TD_DrillStems(i)%StartAngle)
       
     else if (TD_DrillStems(i)%HoleType == 1) then
         TD_DrillStems(i)%StaticHookLoad = -(TD_DrillStems(i)%WeightperLength * TD_DrillStems(i)%RCurvature * &
                                            (sin(TD_DrillStems(i)%EndAngle) - sin(TD_DrillStems(i)%StartAngle)))
       
     else if (TD_DrillStems(i)%HoleType == 2) then
         TD_DrillStems(i)%StaticHookLoad = (TD_DrillStems(i)%WeightperLength * TD_DrillStems(i)%RCurvature * &
                                            (sin(TD_DrillStems(i)%EndAngle) - sin(TD_DrillStems(i)%StartAngle)))  
     end if
     
     
   
     do i = 2, TD_DrillStemComponentsNumbs
         
         if(TD_DrillStems(i)%HoleType == 0) then
             TD_DrillStems(i)%StaticHookLoad = TD_DrillStems(i-1)%StaticHookLoad + TD_DrillStems(i)%WeightperLength * TD_DrillStems(i)%Length * &
                                                TD_DrillStems(i)%BouyancyFactor * cos(TD_DrillStems(i)%StartAngle)
       
         else if (TD_DrillStems(i)%HoleType == 1) then
             TD_DrillStems(i)%StaticHookLoad = TD_DrillStems(i-1)%StaticHookLoad -(TD_DrillStems(i)%WeightperLength * TD_DrillStems(i)%RCurvature * &
                                                (sin(TD_DrillStems(i)%EndAngle) - sin(TD_DrillStems(i)%StartAngle)))
       
         else if (TD_DrillStems(i)%HoleType == 2) then
             TD_DrillStems(i)%StaticHookLoad = TD_DrillStems(i-1)%StaticHookLoad +(TD_DrillStems(i)%WeightperLength * TD_DrillStems(i)%RCurvature * &
                                                (sin(TD_DrillStems(i)%EndAngle) - sin(TD_DrillStems(i)%StartAngle)))  
         end if
     
     end do
!     
!---------------------------------------------------------------------------------------------------
!        
        i = 1
        !TD_DrillStems(i)%TotalSHookLoad = TD_DrillStems(i)%StaticHookLoad   ????????????????????????????
        TD_DrillStems(i)%Dl      = TD_DrillStems(i)%StaticHookLoad * TD_DrillStems(i)%Length / TD_DrillStems(i)%Area / TD_DrillStems(i)%ElasticModule
        TD_DrillStems(i)%DlTotal = TD_DrillStems(i)%Dl
        do i = 2 , TD_DrillStemComponentsNumbs 
         !TD_DrillStems(i)%TotalSHookLoad = TD_DrillStems(i-1)%TotalSHookLoad + TD_DrillStems(i)%StaticHookLoad   ?????????????????????????
         TD_DrillStems(i)%Dl      = TD_DrillStems(i)%StaticHookLoad * TD_DrillStems(i)%Length / TD_DrillStems(i)%Area / TD_DrillStems(i)%ElasticModule
         TD_DrillStems(i)%DlTotal = TD_DrillStems(i-1)%DlTotal + TD_DrillStems(i)%Dl
        end do
        
    TD_StaticHookLoad = TD_DrillStems(TD_DrillStemComponentsNumbs)%StaticHookLoad
    TD_DlMax          = TD_DrillStems(TD_DrillStemComponentsNumbs)%DlTotal
    
    
    
    
    
    
   
end subroutine