subroutine TD_ForceReadData
    
   Use CHoistingVariables
   Use TD_DrillStemComponents
   Use TD_WellElements
   Use TD_WellGeometry
   Use TD_GeneralData
   Use TD_StringConnectionData
   Use RTable_VARIABLES, only: RTable
   Use sROP_Variables
   Use TopDrive_VARIABLES, only: TDS
   

   implicit none
   
   
   integer :: i
   
   
   
   TD_DrillStemAxialVelocity = TD_StringVelocity
   Do i = 1 , TD_DrillStemComponentsNumbs
       if ( DriveType==1) then
           TD_DrillStemRotVelocity = (2.d0*pi*TD_DrillStems(i)%RtoolJoint)*(RTable%Speed)/60.d0                   ! RTable%Speed[RPM] ---> TD_DrillStemRotVelocity[ft/s]
       else if ( DriveType==0) then
           TD_DrillStemRotVelocity = (2.d0*pi*TD_DrillStems(i)%RtoolJoint)*(TDS%Speed+RTable%Speed)/60.d0         ! TDS%Speed[RPM] ---> TD_DrillStemRotVelocity[ft/s]
       end if
   End Do
   
   
   
   
   TD_BitTorque = Bit_Torque
   

   
   
   
   !TD_DrillStemAxialVelocity = 0.0        !???????????????????
   !TD_DrillStemRotVelocity   = 0.0        !???????????????????

   
   
   
    TD_DrillStemForceType = 0
    if(TD_DrillStemAxialVelocity > 0.) then  !??????????????????? check
        TD_DrillStemForceType = 1
        if(TD_DrillStemRotVelocity /= 0.d0)   TD_DrillStemForceType = 2
    else if(TD_DrillStemAxialVelocity < 0.d0) then
        TD_DrillStemForceType = 3
        if(TD_DrillStemRotVelocity /= 0.d0) TD_DrillStemForceType = 4
    else if(TD_DrillStemAxialVelocity == 0.d0) then
        TD_DrillStemForceType = 5    !no axial motion
    end if

    
    
    
    
   
end subroutine