subroutine TD_PipePropertiesReadData
    
   Use TD_DrillStemComponents
   Use TD_WellElements
   Use TD_WellGeometry
   Use TD_GeneralData

   implicit none 

   Integer :: i
   
   
!====================================================
!         Set Pipe Properties Data
!====================================================
   
   Do i = 1 , TD_DrillStemComponentsNumbs
       TD_DrillStems(i)%Density        = 7850.d0*0.06242796d0    ![kg/m3]*0.06242796=[lb/ft3]
       TD_DrillStems(i)%ElasticModule  = 200.0d9*0.02088543d0    ![lb/ft2]     !200GPa=29Mpsi  (steel)
   End Do
   
    
   
   
   
end subroutine