MODULE TorqueDragMain
    USE CPumpsVariables
    USE CDrillingConsoleVariables
    USE CDataDisplayConsoleVariables
    USE CSimulationVariables
    USE Pump_VARIABLES
    IMPLICIT NONE
    PUBLIC
    CONTAINS
    
    subroutine TorqueDrag_Setup()
        use CSimulationVariables
        implicit none
        call OnSimulationInitialization%Add(TorqueDrag_Init)
        call OnSimulationStop%Add(TorqueDrag_Init)
        call OnTorqueDragStep%Add(TorqueDrag_Step)
        call OnTorqueDragOutput%Add(TorqueDrag_Output)
        call OnTorqueDragMain%Add(TorqueDragMainBody)
    end subroutine
    
    subroutine TorqueDrag_Init
        implicit none
    end subroutine TorqueDrag_Init
    
    subroutine TorqueDrag_Step
        implicit none
    end subroutine TorqueDrag_Step
    
    subroutine TorqueDrag_Output
        implicit none
    end subroutine TorqueDrag_Output
    
    
    SUBROUTINE TorqueDragMainBody
        USE ifport
        USE ifmt
        USE CSimulationVariables
        !USE TDSUP
        IMPLICIT NONE 
       
        !CALL TD_MainCalculations
 

    END SUBROUTINE TorqueDragMainBody

END MODULE TorqueDragMain