module CReservoirVariables
    implicit none    
    public    
    !constants
    integer :: Gas_FluidType = 0
    integer :: Oil_FluidType = 1
    integer :: Water_FluidType = 2
    
    ! variables
    integer :: FormationNo
    real(8) :: FormationTop
    real(8) :: PressureGradient
    real(8) :: FormationPermeability
    real(8) :: GeothermalGradient
    integer :: FluidType
    real(8) :: FluidGradient
    real(8) :: FluidViscosity
    logical :: InactiveInflux
    logical :: IsAutoMigrationRateSelected
    real(8) :: AutoMigrationRate
    
    logical :: MakeKickSinglePacket
    
    contains    
end module CReservoirVariables