module CAccumulator
    use CAccumulatorVariables
    implicit none    
    public    
    contains
    
    subroutine SetNumberOfBottels(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetNumberOfBottels
    !DEC$ ATTRIBUTES ALIAS: 'SetNumberOfBottels' :: SetNumberOfBottels
        implicit none
        integer, intent(in) :: v
        NumberOfBottels = v
    end subroutine
    
    subroutine SetAccumulatorSystemSize(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetAccumulatorSystemSize
    !DEC$ ATTRIBUTES ALIAS: 'SetAccumulatorSystemSize' :: SetAccumulatorSystemSize
        implicit none
        real*8, intent(in) :: v
        AccumulatorSystemSize = v
    end subroutine
     
    subroutine SetOilTankVolume(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetOilTankVolume
    !DEC$ ATTRIBUTES ALIAS: 'SetOilTankVolume' :: SetOilTankVolume
        implicit none
        real*8, intent(in) :: v
        OilTankVolume = v
    end subroutine
    
    subroutine SetPrechargePressure(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetPrechargePressure
    !DEC$ ATTRIBUTES ALIAS: 'SetPrechargePressure' :: SetPrechargePressure
        implicit none
        real*8, intent(in) :: v
        PrechargePressure = v
    end subroutine
    
    subroutine SetAccumulatorMinimumOperatingPressure(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetAccumulatorMinimumOperatingPressure
    !DEC$ ATTRIBUTES ALIAS: 'SetAccumulatorMinimumOperatingPressure' :: SetAccumulatorMinimumOperatingPressure
        implicit none
        real*8, intent(in) :: v
        AccumulatorMinimumOperatingPressure = v
    end subroutine
    
    subroutine SetElectricPumpOutput(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetElectricPumpOutput
    !DEC$ ATTRIBUTES ALIAS: 'SetElectricPumpOutput' :: SetElectricPumpOutput
        implicit none
        real*8, intent(in) :: v
        ElectricPumpOutput = v
    end subroutine
    
    subroutine SetStartPressure(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetStartPressure
    !DEC$ ATTRIBUTES ALIAS: 'SetStartPressure' :: SetStartPressure
        implicit none
        real*8, intent(in) :: v
        StartPressure = v
    end subroutine
    
    subroutine SetStopPressure(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetStopPressure
    !DEC$ ATTRIBUTES ALIAS: 'SetStopPressure' :: SetStopPressure
        implicit none
        real*8, intent(in) :: v
        StopPressure = v
    end subroutine
    
    subroutine SetAirPlungerPumpOutput(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetAirPlungerPumpOutput
    !DEC$ ATTRIBUTES ALIAS: 'SetAirPlungerPumpOutput' :: SetAirPlungerPumpOutput
        implicit none
        real*8, intent(in) :: v
        AirPlungerPumpOutput = v
    end subroutine
    
    subroutine SetStartPressure2(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetStartPressure2
    !DEC$ ATTRIBUTES ALIAS: 'SetStartPressure2' :: SetStartPressure2
        implicit none
        real*8, intent(in) :: v
        StartPressure2 = v
    end subroutine
    
    subroutine SetStopPressure2(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetStopPressure2
    !DEC$ ATTRIBUTES ALIAS: 'SetStopPressure2' :: SetStopPressure2
        implicit none
        real*8, intent(in) :: v
        StopPressure2 = v
    end subroutine
    
end module CAccumulator