module CNearFloorConnection
    use CVoidEventHandlerCollection
    implicit none
    real :: NearFloorConnection = 0
    
    public
    
    type(VoidEventHandlerCollection) :: OnNearFloorConnectionChange
    
    private :: NearFloorConnection
    
    contains
    
    
    subroutine Set_NearFloorConnection(v)
        implicit none
        real , intent(in) :: v
#ifdef ExcludeExtraChanges
        if(NearFloorConnection == v) return
#endif
        NearFloorConnection = v
#ifdef deb
        print*, 'NearFloorConnection=', NearFloorConnection
#endif
        call OnNearFloorConnectionChange%RunAll()
    end subroutine
    
    real function Get_NearFloorConnection()
        implicit none
        Get_NearFloorConnection = NearFloorConnection
        !Get_NearFloorConnection = 4
    end function
    
    
    
    
    subroutine Set_NearFloorConnection_WN(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: Set_NearFloorConnection_WN
    !DEC$ ATTRIBUTES ALIAS: 'Set_NearFloorConnection_WN' :: Set_NearFloorConnection_WN
        implicit none
        real , intent(in) :: v
        call Set_NearFloorConnection(v)
    end subroutine
    
    
    real function Get_NearFloorConnection_WN()
    !DEC$ ATTRIBUTES DLLEXPORT :: Get_NearFloorConnection_WN
    !DEC$ ATTRIBUTES ALIAS: 'Get_NearFloorConnection_WN' :: Get_NearFloorConnection_WN
        implicit none
        Get_NearFloorConnection_WN = NearFloorConnection
        !Get_NearFloorConnection_WN = 4
    end function
    
    
    
    subroutine Subscribe_NearFloorConnection()
        implicit none
    end subroutine
    
end module CNearFloorConnection