module CTdsStemJointHeight
    use CVoidEventHandlerCollection
    implicit none
    real :: TdsStemJointHeight = 0
        
    public
    type(VoidEventHandlerCollection) :: OnTdsStemJointHeightChange
    
    private :: TdsStemJointHeight
    
    contains
    
    subroutine Set_TdsStemJointHeight(v)
        implicit none
        real , intent(in) :: v
#ifdef ExcludeExtraChanges
        if(TdsStemJointHeight == v) return
#endif
        TdsStemJointHeight = v
#ifdef deb
        print*, 'TdsStemJointHeight=', TdsStemJointHeight
#endif
        call OnTdsStemJointHeightChange%RunAll()
    end subroutine
    
    real function Get_TdsStemJointHeight()
        implicit none
        Get_TdsStemJointHeight = TdsStemJointHeight
    end function
    
    
    
    
    subroutine Set_TdsStemJointHeight_WN(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: Set_TdsStemJointHeight_WN
    !DEC$ ATTRIBUTES ALIAS: 'Set_TdsStemJointHeight_WN' :: Set_TdsStemJointHeight_WN
        implicit none
        real , intent(in) :: v
        call Set_TdsStemJointHeight(v)
    end subroutine
    
    real function Get_TdsStemJointHeight_WN()
    !DEC$ ATTRIBUTES DLLEXPORT :: Get_TdsStemJointHeight_WN
    !DEC$ ATTRIBUTES ALIAS: 'Get_TdsStemJointHeight_WN' :: Get_TdsStemJointHeight_WN
        implicit none
        Get_TdsStemJointHeight_WN = TdsStemJointHeight
    end function
    
    
    
    subroutine Subscribe_TdsStemJointHeight()
        implicit none
    end subroutine
    
end module CTdsStemJointHeight