module TestOperationScenariosVariables
    implicit none
    public
    
    ! Input vars

    ! Output vars
    integer :: ElevatorConnection
    integer :: KellyConnection
    logical :: CloseKellyCockLed
    logical :: CloseSafetyValveLed
    logical :: FillMouseHoleLed
    logical :: IrIBopLed
    logical :: IrSafetyValveLed
    logical :: LatchLed
    logical :: OpenKellyCockLed
    logical :: OpenSafetyValveLed
    logical :: SlipsNotification
    logical :: SwingLed
    logical :: TongNotification
    logical :: UnlatchLed
    logical :: InstallFillupHeadPermission
    logical :: InstallMudBucketPermission
    logical :: IrIbopPermission
    logical :: IrSafetyValvePermission
    logical :: RemoveFillupHeadPermission
    logical :: RemoveMudBucketPermission
    real(8) :: HookHeightU
    real(8) :: IbopHeight
    real(8) :: NearFloorConnection
    real(8) :: SafetyValveHeight
    logical :: SlackOff
    integer :: StandRackU
    real(8) :: RotaryRpmU
    real(8) :: StringPressure
    logical :: ZeroStringSpeed
    real(8) :: FlowRateU
    real(8) :: PedalU
    real(8) :: FloorHeightU
    real(8) :: CrownHeightU
    real(8) :: KellyHoseVibrationRateU
    integer :: DriveTypeU
    logical :: ElevatorConnected
    logical :: JointConnectionPossibility
    logical :: NearMonkeyBoardPosition
    logical :: NearFloorPosition
    logical :: SingleSetInMouseHole
    logical :: SwingCenter
    integer :: MudBucket
    integer :: Elevator
    integer :: Flow
    integer :: FillupHead
    integer :: Ibop
    integer :: Kelly
    integer :: MouseHole
    integer :: OperationCondition
    integer :: SafetyValve
    integer :: Slips
    integer :: Swing
    integer :: Tong
    integer :: StringUpdateU
    integer :: NewHookHeightU
    integer :: BlowoutFromStringPercentU
    logical :: MakeupTong
    logical :: BreakupTong
    logical :: SlipsSet
    logical :: SlipsUnSet
    logical :: Latch
    logical :: Unlatch
    logical :: OutOfMouseHole
    logical :: IsKellyBushingSetInTable
    
    
    logical :: Signal1U
    logical :: Signal2U
    logical :: Signal3U
    logical :: Signal4U
    logical :: Signal5U
    logical :: Signal6U
    logical :: Signal7U
    logical :: Signal8U
    logical :: Signal9U
    logical :: Signal10U
    
    logical :: BlowoutFromStringT
    logical :: BlowoutFromAnnularT
    logical :: FlowFromReturnLineT
    logical :: FlowFromKellyT
    logical :: FlowKellyDisconnectT
    logical :: FlowPipeDisconnectT
    
    logical :: SingleOutOfMouseHole

    
    contains
end module TestOperationScenariosVariables