module CDrillStemProblems
	use CDrillStemProblemsVariables
	implicit none    
	public 
    contains   
    
    ! Input routines
    subroutine SetStringDragIncrease(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetStringDragIncrease
    !DEC$ ATTRIBUTES ALIAS: 'SetStringDragIncrease' :: SetStringDragIncrease
	    implicit none
	    type(CProblem), intent(in) :: v
	    StringDragIncrease = SetDue(v, ChangeStringDragIncrease)
#ifdef deb
	    print*, 'StringDragIncrease%ProblemType=', StringDragIncrease%ProblemType
	    print*, 'StringDragIncrease%StatusType=', StringDragIncrease%StatusType
	    print*, 'StringDragIncrease%Value=', StringDragIncrease%Value
#endif
    end subroutine

    subroutine SetStringTorqueIncrease(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetStringTorqueIncrease
    !DEC$ ATTRIBUTES ALIAS: 'SetStringTorqueIncrease' :: SetStringTorqueIncrease
	    implicit none
	    type(CProblem), intent(in) :: v
	    StringTorqueIncrease = SetDue(v, ChangeStringTorqueIncrease)
#ifdef deb
	    print*, 'StringTorqueIncrease%ProblemType=', StringTorqueIncrease%ProblemType
	    print*, 'StringTorqueIncrease%StatusType=', StringTorqueIncrease%StatusType
	    print*, 'StringTorqueIncrease%Value=', StringTorqueIncrease%Value
#endif
    end subroutine

    subroutine SetStringTorqueFluctuation(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetStringTorqueFluctuation
    !DEC$ ATTRIBUTES ALIAS: 'SetStringTorqueFluctuation' :: SetStringTorqueFluctuation
	    implicit none
	    type(CProblem), intent(in) :: v
	    StringTorqueFluctuation = SetDue(v, ChangeStringTorqueFluctuation)
#ifdef deb
	    print*, 'StringTorqueFluctuation%ProblemType=', StringTorqueFluctuation%ProblemType
	    print*, 'StringTorqueFluctuation%StatusType=', StringTorqueFluctuation%StatusType
	    print*, 'StringTorqueFluctuation%Value=', StringTorqueFluctuation%Value
#endif
    end subroutine

    subroutine SetStringDragIncreaseTime(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetStringDragIncreaseTime
    !DEC$ ATTRIBUTES ALIAS: 'SetStringDragIncreaseTime' :: SetStringDragIncreaseTime
	    implicit none
	    real(8), intent(in) :: v
	    StringDragIncreaseTime = v
#ifdef deb
	print*, 'StringDragIncreaseTime=', StringDragIncreaseTime
#endif
    end subroutine

    subroutine SetStringTorqueIncreaseTime(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetStringTorqueIncreaseTime
    !DEC$ ATTRIBUTES ALIAS: 'SetStringTorqueIncreaseTime' :: SetStringTorqueIncreaseTime
	    implicit none
	    real(8), intent(in) :: v
	    StringTorqueIncreaseTime = v
#ifdef deb
	print*, 'StringTorqueIncreaseTime=', StringTorqueIncreaseTime
#endif
    end subroutine
    
end module CDrillStemProblems