module CHoistingProblems
    use CHoistingProblemsVariables
	implicit none    
	public 
    contains
    
    ! Input routines
	subroutine SetMotorFail(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetMotorFail
	!DEC$ ATTRIBUTES ALIAS: 'SetMotorFail' :: SetMotorFail
		implicit none
		type(CProblem), intent(in) :: v
		MotorFail = SetDue(v, ChangeMotorFail)
#ifdef deb
	    print*, 'MotorFail%ProblemType=', MotorFail%ProblemType
	    print*, 'MotorFail%StatusType=', MotorFail%StatusType
	    print*, 'MotorFail%Value=', MotorFail%Value
#endif
	end subroutine

	subroutine SetClutchEngage(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetClutchEngage
	!DEC$ ATTRIBUTES ALIAS: 'SetClutchEngage' :: SetClutchEngage
		implicit none
		type(CProblem), intent(in) :: v
		ClutchEngage = SetDue(v, ChangeClutchEngage)
#ifdef deb
	    print*, 'ClutchEngage%ProblemType=', ClutchEngage%ProblemType
	    print*, 'ClutchEngage%StatusType=', ClutchEngage%StatusType
	    print*, 'ClutchEngage%Value=', ClutchEngage%Value
#endif
	end subroutine

	subroutine SetClutchDisengage(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetClutchDisengage
	!DEC$ ATTRIBUTES ALIAS: 'SetClutchDisengage' :: SetClutchDisengage
		implicit none
		type(CProblem), intent(in) :: v
		ClutchDisengage = SetDue(v, ChangeClutchDisengage)
#ifdef deb
	    print*, 'ClutchDisengage%ProblemType=', ClutchDisengage%ProblemType
	    print*, 'ClutchDisengage%StatusType=', ClutchDisengage%StatusType
	    print*, 'ClutchDisengage%Value=', ClutchDisengage%Value
#endif
    end subroutine

end module CHoistingProblems