module CPumpProblems
    use CPumpProblemsVariables
	implicit none    
	public 
    contains
    
    ! Input routines
	subroutine SetPump1PowerFail(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetPump1PowerFail
	!DEC$ ATTRIBUTES ALIAS: 'SetPump1PowerFail' :: SetPump1PowerFail
		implicit none
		type(CProblem), intent(in) :: v
		Pump1PowerFail = SetDue(v, ChangePump1PowerFail)
#ifdef deb
	    print*, 'Pump1PowerFail%ProblemType=', V%ProblemType
	    print*, 'Pump1PowerFail%StatusType=', V%StatusType
	    print*, 'Pump1PowerFail%Value=', V%Value
#endif
	end subroutine

	subroutine SetPump1BlowPopOffValve(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetPump1BlowPopOffValve
	!DEC$ ATTRIBUTES ALIAS: 'SetPump1BlowPopOffValve' :: SetPump1BlowPopOffValve
		implicit none
		type(CProblem), intent(in) :: v
		Pump1BlowPopOffValve = SetDue(v, ChangePump1BlowPopOffValve)
#ifdef deb
	    print*, 'Pump1BlowPopOffValve%ProblemType=', V%ProblemType
	    print*, 'Pump1BlowPopOffValve%StatusType=', V%StatusType
	    print*, 'Pump1BlowPopOffValve%Value=', V%Value
#endif
	end subroutine

	subroutine SetPump2PowerFail(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetPump2PowerFail
	!DEC$ ATTRIBUTES ALIAS: 'SetPump2PowerFail' :: SetPump2PowerFail
		implicit none
		type(CProblem), intent(in) :: v
		Pump2PowerFail = SetDue(v, ChangePump2PowerFail)
#ifdef deb
	    print*, 'Pump2PowerFail%ProblemType=', V%ProblemType
	    print*, 'Pump2PowerFail%StatusType=', V%StatusType
	    print*, 'Pump2PowerFail%Value=', V%Value
#endif
	end subroutine

	subroutine SetPump2BlowPopOffValve(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetPump2BlowPopOffValve
	!DEC$ ATTRIBUTES ALIAS: 'SetPump2BlowPopOffValve' :: SetPump2BlowPopOffValve
		implicit none
		type(CProblem), intent(in) :: v
		Pump2BlowPopOffValve = SetDue(v, ChangePump2BlowPopOffValve)
#ifdef deb
	    print*, 'Pump2BlowPopOffValve%ProblemType=', V%ProblemType
	    print*, 'Pump2BlowPopOffValve%StatusType=', V%StatusType
	    print*, 'Pump2BlowPopOffValve%Value=', V%Value
#endif
	end subroutine

	subroutine SetCementPumpPowerFail(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetCementPumpPowerFail
	!DEC$ ATTRIBUTES ALIAS: 'SetCementPumpPowerFail' :: SetCementPumpPowerFail
		implicit none
		type(CProblem), intent(in) :: v
		CementPumpPowerFail = SetDue(v, ChangeCementPumpPowerFail)
#ifdef deb
	    print*, 'CementPumpPowerFail%ProblemType=', V%ProblemType
	    print*, 'CementPumpPowerFail%StatusType=', V%StatusType
	    print*, 'CementPumpPowerFail%Value=', V%Value
#endif
	end subroutine

	subroutine SetCementPumpBlowPopOffValve(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetCementPumpBlowPopOffValve
	!DEC$ ATTRIBUTES ALIAS: 'SetCementPumpBlowPopOffValve' :: SetCementPumpBlowPopOffValve
		implicit none
		type(CProblem), intent(in) :: v
		CementPumpBlowPopOffValve = SetDue(v, ChangeCementPumpBlowPopOffValve)
#ifdef deb
	    print*, 'CementPumpBlowPopOffValve%ProblemType=', V%ProblemType
	    print*, 'CementPumpBlowPopOffValve%StatusType=', V%StatusType
	    print*, 'CementPumpBlowPopOffValve%Value=', V%Value
#endif
    end subroutine

end module CPumpProblems