module ChokeControlMain
    implicit none
    public
    contains
    
    subroutine ChokeControl_Setup()
        use CSimulationVariables
        implicit none
        call OnSimulationInitialization%Add(ChokeControl_Init)
        call OnSimulationStop%Add(ChokeControl_Init)
        call OnChokeControlStep%Add(ChokeControl_Step)
        call OnChokeControlOutput%Add(ChokeControl_Output)
        call OnChokeControlMain%Add(ChokeControlMainBody)
    end subroutine
    
    subroutine ChokeControl_Init
        implicit none
    end subroutine ChokeControl_Init
    
    subroutine ChokeControl_Step
        implicit none
    end subroutine ChokeControl_Step
    
    subroutine ChokeControl_Output
        implicit none
    end subroutine ChokeControl_Output
        
    subroutine ChokeControlMainBody
        use CRigSizeVariables
        use CHOKE       
        implicit none

         CALL Choke_StartUp()
        loop1: DO
            CALL CHOKE_MainBody
            call sleepqq(100)
            !IF (IsStopped==.true.) THEN
            !    EXIT loop1
            !ENDIF
    !write(*,*) '1111111111111'
      if(IsStopped) then
!write(*,*) '22222222222222'
          
          CALL DEALLOCATE_ARRAYS_CHOKE()
!write(*,*) '333333333'
          
          call Quit()
      end if            
            
            

        ENDDO loop1 
        
        CLOSE(150)
        
        !CALL DEALLOCATE_ARRAYS_CHOKE()
        
    end subroutine ChokeControlMainBody
    
end module ChokeControlMain