subroutine Drawworks_Free_Traction_motor_Dir


    use CDrillingConsoleVariables
    use CDataDisplayConsoleVariables
    use Drawworks_VARIABLES
   
    IMPLICIT NONE
   
    
    Integer :: jj, kk
    REAL, allocatable, dimension(:) :: w_array
    REAL    :: sigma_w
    
    
    
    
    
    !Drawworks%w_drum = Drawworks%w/Drawworks%Conv_Ratio
    
    Drawworks%time  = Drawworks%time_step
    Drawworks%dt    = 1.d-5
    Drawworks%error = .001
    
    Drawworks%w_drum_Dir     = Drawworks%w_drum
    Drawworks%w_old_drum_Dir = Drawworks%w_old_drum
    
!>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    
    Drawworks%n = Drawworks%time/Drawworks%dt
    
    Drawworks%i = 1
    
!>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<   
    DO WHILE (Drawworks%i<=Drawworks%n)        
 
        
        !>>>>>>>>>>>>  Runge-Kutta Method (2nd order)  <<<<<<<<<<<<<<
          
        call dw_freeTrac((Drawworks%i*Drawworks%dt),Drawworks%w_drum_Dir)
        Drawworks%K1w = Drawworks%dt*Drawworks%dw_freeTrac
          
        call dw_freeTrac((Drawworks%i*Drawworks%dt)+(Drawworks%dt),Drawworks%w_drum_Dir+(Drawworks%K1w))
        Drawworks%K2w = Drawworks%dt*Drawworks%dw_freeTrac

        Drawworks%w_new_drum_Dir = Drawworks%w_old_drum_Dir+((Drawworks%K1w+Drawworks%K2w)/2.0d0)

        Drawworks%w_old_drum_Dir = Drawworks%w_new_drum_Dir
        Drawworks%w_drum_Dir     = Drawworks%w_new_drum_Dir

        Drawworks%i = Drawworks%i+1
        
          
    END DO
!>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

    
    
    
    
END subroutine Drawworks_Free_Traction_motor_Dir