subroutine Pump3_OffMode_Solver
    
    use Pump_VARIABLES
    use CPumpsVariables
    use CDrillingConsoleVariables
    use CDataDisplayConsoleVariables
    use CSimulationVariables
    use CDrillWatchVariables
    use CSounds
    
    
    IMPLICIT NONE
    INTEGER :: Pump_No
    
    
    
        CALL Pump_INPUTS
        
        
        
        !==================================================================
        !                  Rate limit for off Mode
        
        Do while (((PUMP(3)%N_old-0.0d0)/PUMP(3)%time_step)>386.)
            PUMP(3)%N_ref = (-386.*PUMP(3)%time_step)+PUMP(3)%N_old
            !else
            !    PUMP(1)%N_ref=0.0d0
            !end if
        
            Call Pump3_OnMode_Solver
        
            PUMP(3)%N_old = PUMP(3)%N_ref
            Call sleepqq (80)  !?????????????????
        End Do
        !==================================================================
        
        
        
        
        PUMP(3)%Speed  = 0.0
        
        Call Pump_Solver(3)
                        
        Call Pump_Total_Counts
        
        
        Call Set_MP1SPMGauge( real((PUMP(3)%Speed/PUMP(3)%Trans_Ratio),8) )
        SPM1 = MP1SPMGauge
        PUMP(3)%SoundSPM = INT(PUMP(3)%Speed/PUMP(3)%Trans_Ratio)
        Call SetSoundMP3( PUMP(3)%SoundSPM )
        
        
        
        
end subroutine Pump3_OffMode_Solver