subroutine Pump_INPUTS

    use CPumpsVariables
    use CDrillingConsoleVariables
    use CDataDisplayConsoleVariables
    use CSimulationVariables
    use Pump_VARIABLES
    use MudSystem

	IMPLICIT NONE
    
    
    
!>>>>>>>>>>>>>>>>>>>>>>>  PUMP 1  <<<<<<<<<<<<<<<<<<<<<<<<<<<

    if ( PUMP(1)%BlowPopOffMalf==1 ) then     ! Pump1 Malfunction ----> Blow Pop-offs (Relief Valves)
        PUMP(1)%StandPipe_Pressure = 0.d0
    else
        PUMP(1)%StandPipe_Pressure = PumpPressure1       ![psi]
        if ( PUMP(1)%StandPipe_Pressure<=14. ) then
            PUMP(1)%StandPipe_Pressure = 14.
        end if
    end if
    

    
    
    
!>>>>>>>>>>>>>>>>>>>>>>>  PUMP 2  <<<<<<<<<<<<<<<<<<<<<<<<<<<

    if ( PUMP(2)%BlowPopOffMalf==1 ) then     ! Pump2 Malfunction ----> Blow Pop-offs (Relief Valves)
        PUMP(2)%StandPipe_Pressure = 0.d0
    else
        PUMP(2)%StandPipe_Pressure = PumpPressure2       ![psi]
        if ( PUMP(2)%StandPipe_Pressure<=14. ) then
            PUMP(2)%StandPipe_Pressure = 14.
        end if
    end if
    
    
    
    
    
!>>>>>>>>>>>>>>>>>>>>>>>  PUMP 3  <<<<<<<<<<<<<<<<<<<<<<<<<<<
  
    if ( PUMP(3)%BlowPopOffMalf==1 ) then     ! Pump3 Malfunction ----> Blow Pop-offs (Relief Valves)
        PUMP(3)%StandPipe_Pressure = 0.d0
    else
        PUMP(3)%StandPipe_Pressure = PumpPressure3       ![psi]
        if ( PUMP(3)%StandPipe_Pressure<=14. ) then
            PUMP(3)%StandPipe_Pressure = 14.
        end if
    end if
  
    
    
    
    
end subroutine Pump_INPUTS