subroutine JetImpactForce

    use sROP_Other_Variables
    use sROP_Variables
    use CStringConfigurationVariables
    use CformationVariables
    use CSimulationVariables
    use CmudPropertiesVariables
    use MudSystemVARIABLES
    
    implicit none
    
    Real(8) :: DeltaPb , NozzleTotalArea , Cd=0.95d0
    
    
    
    
    Bit_Flowrate    = StringFlowRateFinal      ![gpm]
    !print*, 'Bit_Flowrate=' , Bit_Flowrate
    !check :: Mud_Density [ppg]   ??????????
    
    NozzleTotalArea = Number_of_Bit_Nozzles*(Diameter_of_Bit_Nozzle**2)*(PI/4.d0)
    
    DeltaPb         = (8.311d-5*Mud_Density*(Bit_Flowrate**2))/((Cd**2)*(NozzleTotalArea**2))
    
    JetImpact_Force = 0.01823d0*Cd*Bit_Flowrate*sqrt(Mud_Density*DeltaPb)
    
    
    
    
end subroutine