module sROP_Other_Variables
    
implicit none
integer :: FormationNumber
real(8) :: FormationTopDepth, Condition
CHARACTER(len=20) :: filename     ! Name of file to open
INTEGER :: name , status                 ! I/O status
REAL(8) :: H1, H2, H3, w_d_max                     ! The real value read in
! $$$$$**$$$$$**$$$$$**$$$$$**$$    End of Introduction of Module Inputs   $$**$$$$$**$$$$$**$$$$$**$$$$$
character(len = 20) :: Formation_Type = 'Shale' ! Default = Shale    
! -----**-----**-----**-----**-----**             Bit Type:            *-----**-----**-----**-----**-----    
Integer :: Bit_Class                    ! Default = Rollar Cone
real(8) :: Diameter_of_Bit              ! unit : [in.] (Typical Range: 3.0 to 30.0)   
Integer :: Number_of_Bit_Nozzles        ! (Typical Range: 1 to 10)    
real(8) :: Diameter_of_Bit_Nozzle       ! unit : [1/32 in.] (Typical Values: 8.0 to 32.0)
! -----**-----**-----**-----**-----**          End of Bit Type:        *-----**-----**-----**-----**-----
real(8) :: Critical_Mud_Density         ! unit : [ppg] or [lb/gal] (Typical Range: 0 to 10.0)
real(8) :: Critical_Weight_on_Bit                 ! unit : [klb] (Typical Range: 0 to 10)
real(8) :: Reynolds_Number              ! unit : [klb] (Typical Range: 0.1 to 1000.0)
! -----**-----**-----**-----**-----**    Other Rate_of_Penetration Model Variables:    *-----**-----**-----**-----**-----
real(8) :: x1, x2, x3, x4, x5, x6, x7, x8
real(8) :: f1, f2, f3, f4, f5, f6, f7, f8
real(8) :: a1, a2, a3, a4, a5, a6, a7, a8
real(8) :: Br_Coef
real(8) :: dt , Tou_H
integer,dimension(8) :: ROP_StartTime , ROP_EndTime
! -----**-----**-----**-----**---    End of Other Rate_of_Penetration Model Variables     ---**-----**-----**-----**-----
real(8), parameter  :: PI = 3.1415926      ! PI Number
! $$$$$**$$$$$**$$$$$**$$$$$**$$$$$**    End of Variable Definition    *$$$$$**$$$$$**$$$$$**$$$$$**$$$$$ 

end module sROP_Other_Variables