subroutine TD_BouyancyFactor (i)
    
   Use TD_DrillStemComponents
   Use TD_WellElements
   Use TD_WellGeometry
   Use TD_GeneralData
   

   implicit none
   
   Integer :: i

   
   

!====================================================
!           Bouyancy Factor Calculation
!====================================================
   
   if ( TD_DrillStems(i)%MudDensityOut==0.d0 .or. TD_DrillStems(i)%MudDensityIn==0.d0 ) then
       TD_DrillStems(i)%BouyancyFactor = 0.d0
   else
       TD_DrillStems(i)%BouyancyFactor = 1.d0-( ((TD_DrillStems(i)%MudDensityOut*(TD_DrillStems(i)%Od**2)/4.0d0) &
                                        -(TD_DrillStems(i)%MudDensityIn*(TD_DrillStems(i)%Id**2)/4.0d0)) &
                                        /(TD_DrillStems(i)%Density*((TD_DrillStems(i)%Od**2-TD_DrillStems(i)%Id**2))/4.0d0) )
   end if
   
   
 
   
   
end subroutine 