subroutine TD_ForceDownS(i,TD_SemiMudVisc)
    
   Use TD_DrillStemComponents
   Use TD_WellElements
   Use TD_WellGeometry
   Use TD_GeneralData
   

   implicit none
   
   Integer :: i
   Real(8) :: TD_SemiMudVisc , TD_SemiAngle
   
   
   if ( TD_DrillStems(i)%StartAngle<=(pi/180.) ) then
       TD_SemiAngle = (pi/180.)
   else
       TD_SemiAngle = TD_DrillStems(i)%StartAngle
   end if
   
   
   If (i==1) then
       TD_DrillStems(1)%Force1 = -TD_WeightOnBit
       TD_DrillStems(i)%Force2 = TD_DrillStems(i)%Force1 +  (TD_DrillStems(i)%WeightperLength * TD_DrillStems(i)%Length * &
                            TD_DrillStems(i)%BouyancyFactor * (cos(TD_DrillStems(i)%StartAngle) - &
                            (TD_SemiMudVisc * sin(TD_DrillStems(i)%StartAngle))))
       
       
       if (TD_DrillStems(i)%ComponentType==0) then
           TD_DrillStems(i)%Torque = TD_BitTorque
       else
           TD_DrillStems(i)%Torque = TD_SemiMudVisc* TD_DrillStems(i)%BouyancyFactor* &
                            TD_DrillStems(i)%WeightperLength* TD_DrillStems(i)%Length* TD_DrillStems(i)%RtoolJoint * &
                            sin(TD_SemiAngle)
       end if
       
       
       return
   End If
   
   
!=========> F1 Calculation
   TD_DrillStems(i)%Force1 = TD_DrillStems(i-1)%Force2
   
    
!=========> F2 Calculation
    TD_DrillStems(i)%Force2 = TD_DrillStems(i)%Force1 +  (TD_DrillStems(i)%WeightperLength * TD_DrillStems(i)%Length * &
                            TD_DrillStems(i)%BouyancyFactor * (cos(TD_DrillStems(i)%StartAngle) - &
                            (TD_SemiMudVisc * sin(TD_DrillStems(i)%StartAngle))))
   !
   !
   !Strains(i)%Dl = TDForces(i)%Force * (Elements(i)%Length  ) / &
   !                          (Elements(i)%Area * Element%ElasticModule)
   !       
   
   TD_DrillStems(i)%Torque = TD_SemiMudVisc* TD_DrillStems(i)%BouyancyFactor* &
                            TD_DrillStems(i)%WeightperLength* TD_DrillStems(i)%Length* TD_DrillStems(i)%RtoolJoint * &
                            sin(TD_SemiAngle)
   !
   
   
   
   
end subroutine