subroutine TD_ForceDownSRot(i,TD_SemiMudVisc)
    
   Use TD_DrillStemComponents
   Use TD_WellElements
   Use TD_WellGeometry
   Use TD_GeneralData
   

   implicit none
    
   Integer :: i
   Real(8) :: TD_SemiMudVisc , TD_SemiAngle
    
   
   if ( TD_DrillStems(i)%StartAngle<=(pi/180.) ) then
       TD_SemiAngle = (pi/180.)
   else
       TD_SemiAngle = TD_DrillStems(i)%StartAngle
   end if
   
    
   If (i==1) then
       TD_DrillStems(1)%Force1 = -TD_WeightOnBit
       TD_DrillStems(i)%Force2 = TD_DrillStems(i)%Force1 + (TD_DrillStems(i)%BouyancyFactor * TD_DrillStems(i)%WeightperLength * TD_DrillStems(i)%Length * &
                            cos(TD_DrillStems(i)%StartAngle)) - (TD_SemiMudVisc * TD_DrillStems(i)%BouyancyFactor * &
                            TD_DrillStems(i)%WeightperLength * TD_DrillStems(i)%Length * &
                            sin(TD_DrillStems(i)%StartAngle) * sin(TD_DrillStems(i)%CombVelRatio))
       
       
       if (TD_DrillStems(i)%ComponentType==0) then
           TD_DrillStems(i)%Torque = TD_BitTorque
       else
           TD_DrillStems(i)%Torque = TD_DrillStems(i)%RtoolJoint * TD_SemiMudVisc * TD_DrillStems(i)%BouyancyFactor * &
                            TD_DrillStems(i)%WeightperLength * TD_DrillStems(i)%Length * sin(TD_SemiAngle) * cos(TD_DrillStems(i)%CombVelRatio)
       end if
       
       
       return
   End If
   
   
!=========> F1 Calculation
   TD_DrillStems(i)%Force1 = TD_DrillStems(i-1)%Force2
   
    
!=========> F2 Calculation
    TD_DrillStems(i)%Force2 = TD_DrillStems(i)%Force1 + (TD_DrillStems(i)%BouyancyFactor * TD_DrillStems(i)%WeightperLength * TD_DrillStems(i)%Length * &
                            cos(TD_DrillStems(i)%StartAngle)) - (TD_SemiMudVisc * TD_DrillStems(i)%BouyancyFactor * &
                            TD_DrillStems(i)%WeightperLength * TD_DrillStems(i)%Length * &
                            sin(TD_DrillStems(i)%StartAngle) * sin(TD_DrillStems(i)%CombVelRatio))
    !    
    TD_DrillStems(i)%Torque = TD_DrillStems(i)%RtoolJoint * TD_SemiMudVisc * TD_DrillStems(i)%BouyancyFactor * &
                            TD_DrillStems(i)%WeightperLength * TD_DrillStems(i)%Length * sin(TD_SemiAngle) * cos(TD_DrillStems(i)%CombVelRatio)
        
    !    
    !Strains(i)%dL = TDForces(i)%Force * (Elements(i)%Length) / &
    !                         (Elements(i)%Area * Element%ElasticModule)
        
    
end subroutine