subroutine TD_StrainCalculation(i)
    
   Use TD_DrillStemComponents
   Use TD_WellElements
   Use TD_WellGeometry
   Use TD_GeneralData
   

   implicit none
   
   Integer :: i
    
    
    
    if (TD_DrillStemAxialVelocity>=0.d0) then
       
        if (i == 1) then
            TD_DrillStems(i)%Force2  = TD_DrillStems(i)%Force2 + TD_DrillStems(i)%Drag
            TD_DrillStems(i)%Dl      = (TD_DrillStems(i)%Force2) * TD_DrillStems(i)%Length / TD_DrillStems(i)%Area / TD_DrillStems(i)%ElasticModule
            TD_DrillStems(i)%DlTotal = TD_DrillStems(i)%Dl
        else
        !do i = 2 , TD_DrillStemComponentsNumbs
            TD_DrillStems(i)%Force2  = TD_DrillStems(i)%Force2 + TD_DrillStems(i)%Drag
            TD_DrillStems(i)%Dl      = (TD_DrillStems(i)%Force2) * TD_DrillStems(i)%Length / TD_DrillStems(i)%Area / TD_DrillStems(i)%ElasticModule
            TD_DrillStems(i)%DlTotal = TD_DrillStems(i-1)%DlTotal + TD_DrillStems(i)%Dl
        !end do
        end if
        
        
    else if (TD_DrillStemAxialVelocity<0.) then
        
       if (i == 1) then
        TD_DrillStems(i)%Force2  = TD_DrillStems(i)%Force2 - TD_DrillStems(i)%Drag
        TD_DrillStems(i)%Dl      = (TD_DrillStems(i)%Force2) * TD_DrillStems(i)%Length / TD_DrillStems(i)%Area / TD_DrillStems(i)%ElasticModule
        TD_DrillStems(i)%DlTotal = TD_DrillStems(i)%Dl
       else
        !do i = 2 , TD_DrillStemComponentsNumbs 
            TD_DrillStems(i)%Force2  = TD_DrillStems(i)%Force2 - TD_DrillStems(i)%Drag
            TD_DrillStems(i)%Dl      = (TD_DrillStems(i)%Force2) * TD_DrillStems(i)%Length / TD_DrillStems(i)%Area / TD_DrillStems(i)%ElasticModule
            TD_DrillStems(i)%DlTotal = TD_DrillStems(i-1)%DlTotal + TD_DrillStems(i)%Dl
        !end do
       end if
       
        
    end if
    

!=====> Modified Length of Drill Stem
    !TD_DrillStems(i)%Length = TD_DrillStems(i)%LengthIni + TD_DrillStems(i)%Dl
    TD_DrillStems(i)%Length  = TD_DrillStems(i)%LengthIni
     
   
     
end subroutine