MODULE TD_GeneralData
    
    
    Use CDownHoleTypes
    
    IMPLICIT NONE
    PUBLIC
    
    
    
    
!====================================================
!                 General Info
!====================================================
    
!=====> Time Info
    REAL    :: TD_TimeStep
    INTEGER :: TD_IntCPUTime, TD_DtRef
    !REAL   :: TD_StartTime, TD_EndTime
    
    
    
    
    
    
!=====> BOP Info
    !REAL(8)   :: TD_AboveAnnularHeight , TD_AnnularPreventerHeight , TD_UpperRamHeight , TD_LowerRamHeight , TD_BlindRamHeight , TD_KillHeight
    REAL(8)    :: TD_AboveAnnularDiam , TD_AnnularPreventerDiam , TD_UpperRamDiam , TD_LowerRamDiam , TD_BlindRamDiam , TD_KillDiam
    REAL(8) , Dimension(6) :: TD_BOPHeight , TD_BOPDiam
    REAL(8) , Dimension(4) :: TD_BOPRamDiam
    REAL(8)                :: TD_BOPThickness , TD_AnnularFillingFinal
    INTEGER , Dimension(4) :: TD_BOPCondition
    INTEGER , Dimension(6) :: TD_BOPElementNo
    INTEGER , Dimension(6) :: TD_BOPConnectionPossibility    ! 0:impossible   , 1:possible(for DrillPipe Element)
    
    !TYPE , PUBLIC  :: TD_BOPElementData
    !    INTEGER    :: CType
    !    REAL(8)    :: TopDepth , DownDepth
    !END TYPE TD_BOPElementData
    TYPE(CBopElement) :: TD_BOPElement(4)

    
    
!=====> Problems
    INTEGER :: TD_WeightIndicatorMalf
    
    
    
    
    
END MODULE TD_GeneralData