MODULE TD_WellGeometry
    
    
    IMPLICIT NONE
    PUBLIC
        
    
    
    REAL(8) , PARAMETER :: pi=3.14159265
    
    
    
    
!====================================================
!                Well Geometry Info
!====================================================

    INTEGER :: TD_WellIntervalsCount
    REAL(8) :: TD_WellTotalLength , TD_WellTotalVerticalLength
    
    TYPE, PUBLIC :: TD_WellGeometryData
        INTEGER  :: HoleType
        REAL(8)  :: StartAngle , EndAngle , IntervalLength , VerticalDepth , TopDepth , DownDepth , RCurvature
    END TYPE TD_WellGeometryData

    TYPE(TD_WellGeometryData), Allocatable :: TD_WellGeo(:)

    
    
    
    
END MODULE TD_WellGeometry